#include<curses.h>
#include"dimens.h"
#include"common.h"
#include"defs.h"

extern WINDOW *titlebar, *menubar, *textwin, *text, *statbar;
extern Data_structure d;
char *menutab[]= {
		  "Work",
		  "Needs",
		  "Tool kit",
		  "About \"abc\""
		  };

	
void dra_menubar()
 {
   WINDOW *&mbar= menubar;
   mbar= subwin(stdscr,MBAR_LINES, MBAR_COLS, MBAR_YBEG+1, MBAR_XBEG);
   wbkgd(mbar,COLOR_PAIR(5)|A_UNDERLINE);
   for(int i=0; i<4; i++)
     for(int j=0;menutab[i][j] != '\0'; j++)  {
       if(j == 0)  
	 wattrset(mbar, COLOR_PAIR(6));
       mvwaddch(mbar,0,(i)*18+2+j,menutab[i][j]);
       if(j == 0)
	 wattroff(mbar, COLOR_PAIR(6));
      }
   wrefresh(mbar);
  }

void activatetab(int menu_num,WINDOW *menubar)
{
  wattrset(menubar,COLOR_PAIR(7));
  mvwaddstr(menubar,0,(menu_num-1)*18+2,menutab[menu_num-1]);
  touchwin(menubar);
  wrefresh(menubar);
  wattroff(menubar,COLOR_PAIR(7));
 }

void deactivatetab(int menu_num,WINDOW *menubar)
{
     for(int j=0;menutab[menu_num-1][j] != '\0'; j++)  {
       if(j == 0)  
	 wattrset(menubar, COLOR_PAIR(6));
       mvwaddch(menubar,0,(menu_num-1)*18+2+j,menutab[menu_num-1][j]);
       if(j == 0)
	 wattroff(menubar, COLOR_PAIR(6));
      }
      wrefresh(menubar);
 }

void dra_statbar()
{
    WINDOW *&sbar= statbar;
    sbar= subwin(stdscr,1,80,24,0);
   wbkgd(sbar,COLOR_PAIR(statusbar_color_pair)|A_BOLD);
   wrefresh(sbar);
  }

void dra_titlebar()
{
  WINDOW *&tbar= titlebar;
  tbar= subwin(stdscr,1,80,0,0);
  wbkgd(tbar,COLOR_PAIR(4)|A_BOLD);
  waddstr(tbar,"THE abc EDITOR");
  touchwin(tbar);
  wrefresh(tbar);
 }
 
void addto_title_bar()
{
  if(!saved)
    mvwaddch(titlebar, 0, 21, '*');
  else
    mvwaddch(titlebar, 0, 21, ' ');
  if(d.is_readonly())
    mvwaddstr(titlebar, 0, 24, "R/O");
  else
    mvwaddstr(titlebar, 0, 24, "R/W");
  wmove(titlebar, 0, 35);
  wclrtoeol(titlebar);
  mvwaddstr(titlebar, 0, 35, curr_file_name);
  wrefresh(titlebar);
}
  
void start_curses()
{
  initscr();
  start_color();
  noecho();
  cbreak();
  init_pair(menu_color_pair, COLOR_WHITE, COLOR_BLACK);
  init_pair(textwin_color_pair	, COLOR_WHITE, COLOR_BLUE);
  init_pair(statusbar_color_pair, COLOR_WHITE, COLOR_RED);
  // The above objects are only bi-colored, hence, no probs.
  // The color pairs defined below are for multicolored objects
  init_pair(4, 1, 0);      // for titlebar 
  init_pair(5, 0, 6);	   // for menubar
  init_pair(6, 1, 2);	   // for first letter of tab
  init_pair(7, 7, 1);      // for activation tab
  init_pair(8, 4, 0);	   // for permission dialog box - Background
  init_pair(9, 2, 0);      // for above text in perbox
  init_pair(10, 7, 0);
}

void dra_textwin()
{
  WID= 78 - L_m - R_m;
  HGT= 20 - T_m - B_m;
  textwin= subwin(stdscr,22, 80, 2, 0);    
  box(textwin,0,0);
  wbkgd(textwin,COLOR_PAIR(textwin_color_pair)|A_BOLD);
  if(L_m)   mvwaddch(textwin,      0,     L_m, '*');
  if(R_m)   mvwaddch(textwin,      0,  79-R_m, '*');
  if(T_m)   mvwaddch(textwin,    T_m,       0, '*');
  if(B_m)   mvwaddch(textwin, 21-B_m,       0, '*');
  if(L_m)   mvwaddch(textwin,     21,     L_m, '*');
  if(R_m)   mvwaddch(textwin,     21,  79-R_m, '*');
  if(T_m)   mvwaddch(textwin,    T_m,      79, '*');
  if(B_m)   mvwaddch(textwin, 21-B_m,      79, '*');
  wnoutrefresh(textwin);
  
  text= derwin(textwin, HGT, WID, T_m+1 , L_m+1);
  keypad(text,TRUE);
  wbkgd(text,COLOR_PAIR(textwin_color_pair)|A_BOLD);
  wnoutrefresh(text);
  doupdate();
}

void redra_textwin()
{
  delwin(text);
  werase(textwin);
  WID= 78 - L_m - R_m;
  HGT= 20 - T_m - B_m;
  box(textwin,0,0);
  wbkgd(textwin,COLOR_PAIR(textwin_color_pair)|A_BOLD);
  if(L_m)   mvwaddch(textwin,      0,     L_m, '*');
  if(R_m)   mvwaddch(textwin,      0,  79-R_m, '*');
  if(T_m)   mvwaddch(textwin,    T_m,       0, '*');
  if(B_m)   mvwaddch(textwin, 21-B_m,       0, '*');
  if(L_m)   mvwaddch(textwin,     21,     L_m, '*');
  if(R_m)   mvwaddch(textwin,     21,  79-R_m, '*');
  if(T_m)   mvwaddch(textwin,    T_m,      79, '*');
  if(B_m)   mvwaddch(textwin, 21-B_m,      79, '*');
  wnoutrefresh(textwin);
  
  text= derwin(textwin, HGT, WID, T_m+1 , L_m+1);
  keypad(text,TRUE);
  wbkgd(text,COLOR_PAIR(textwin_color_pair)|A_BOLD);
  d.compute_bot();
  wnoutrefresh(text);
  doupdate();
}
