#include<curses.h>
#include<stdlib.h>
#include<malloc.h>
#include<string.h>
#include<assert.h>
#include<ctype.h>
#include"common.h"
#include"dimens.h"
#include"defs.h"
#define LPScr 20
#define TAKE {beep();wgetch(text);}
#define EX {beep();endwin();exit(0);}
char x;
extern int kireek;
extern WINDOW *statbar, *menubar, *text, *textwin;

/*************************	CLASS	NODE	*******************************/
void Node::ins_char_before(char ch,int pos)	// Inserts character before pos
{
  pos--;
  if(last >= size-1)  {
    size+= QUANT;
    tx= (char *)realloc(tx,size);
  }
  for(int i=last; i>=pos; i--)  {
    tx[i+1]= tx[i];
  }            
  tx[pos]= ch;
  tx[++last]= '\0';
}

void Node::del_char(int pos) //  Deletes character at position pos
{
  bool flag=0;
  for(int i=pos; i<=last; i++)  {
    tx[i-1]=tx[i];			
    flag++;
  }
  if(flag)
    last--;
  else
    beep();  
  if(size-last >= QUANT+1)  {
    char temp[size];
    strcpy(temp,tx);
    free(tx);
    size-= QUANT;
    tx= (char*)malloc(size);
    strcpy(tx,temp);
  }
}


/**********************	 HEADER       LIST	 FUNCTIONS  *******************/

void Headerlist::ins_after(Header *ph)
{
  no_of_lines++;
  Header *temp, *temp1= ph->below;
  ph->below= temp= new Header(ph, ph->below);
  if(temp->below == NULL)
    kone= temp;
  if(temp->below != NULL)
    temp->below->above= temp;
 }

void Headerlist::ins_before(Header *ph)
{
  no_of_lines++;
  Header *temp;
  ph->above= temp= new Header(ph->above, ph);
  if(temp->above != NULL)
    temp->above->below= temp;
  else
    shuru= temp;
 }

void Headerlist::del_pos(Header *ph)
{
  no_of_lines--;
  Header *temp= ph;
  if(ph->below == NULL)
    kone= kone->above;
  if(temp->below != NULL)
    temp->below->above= temp->above;
  if(temp->above != NULL)
    temp->above->below= temp->below;
  if(shuru == ph)
    shuru= ph->below;
  delete ph;
 }

Header* Headerlist::up(Header *ph)
{
  return ph->above;
 }

Header* Headerlist::down(Header *ph)
{
  return ph->below;
 }

Header* Headerlist::home()
{
  return shuru;
 }

Header* Headerlist::end()
{
  Header *temp= shuru;
  while(temp->below)
    temp= temp->below;
  return temp;
 }

Header* Headerlist::operator[](int index)
{
  assert(shuru != NULL);
  Header *temp= shuru;
  while(--index)  { 
    assert(temp != NULL);
    temp= temp->below;
  }
  return temp;
}


/*******************	  DATA      STRUCTURE	  FUNCTIONS	***************/

void Data_structure::process(chtype ch)
{
 int which;
 switch(ch)  {
   case KEY_UP    :
	   	   key_up();
		   break;
   case KEY_DOWN  :
	   	   key_down();
		   break;
   case KEY_LEFT  :
		   key_left();
		   break;
   case KEY_RIGHT :
		   key_right();
		   break;
   case HOME	  :
		   goto_homel();
		   break;		   
   case END	  :
		   goto_endl();
		   break;
   case CTRL('u') :
		   up_one_line();
		   break;
   case CTRL('d') :
		   down_one_line();
		   break;
   case DEL	  :
		   if(!readonly)  {
		     saved= FALSE;
		     del_curr_char();
		   }
		   break;
   case	BACKSPACE :
		   if(!readonly)  {
		     saved= FALSE;
	      	     del_prev_char();
		   }
		   else
		     key_left();
	           break;
   case PG_UP     :
		   if(!pg_up())
		     beep();
		   break;
   case PG_DN	  :
		   if(!pg_down())
		     beep();
		   break;
   case CTRL('h') :
		   initialize();
		   compute_bot();
		   break;
   case CTRL('e') :
		   line= top= bot= hls.no_of_lines;
		   s_top= s_bot= no_of_logln(hls.kone);
		   currline= hls.kone;
		   break;
   case  '\n'	  :
		   if(!readonly)  {
		     saved= FALSE;
		     which= key_enter();
	      	     if(col == 1)  {
		       if(line == top)  {
		         s_top= 1;
		         which= 2;
		       }
		       ins_ln_at_home();
		     }
		     else if(col == currline->ptr->last+1)
                       ins_ln_at_end();
	             else
		       ins_ln_at_mid();
		     if(which == 1)
		       compute_top();
		     else
		       compute_bot();
		   }
		   else
		     key_down();
		   
    	           break;
   case '\t'	  :
		   if(!readonly)  {
		     saved= FALSE;
		     if(col == 1 || col%WID == 0)
		       which= TAB;
		     else
		       which= TAB - col%TAB;
		     for(int i=0; i<=which ; i++)  {
		       char_count++;
		       ins_char(' ');
		     }
		   }
		   else
		     key_right();
	      	   break;
   case CTRL('l') :
		   delete_line();
		   break;
   case CTRL('p') :
		   if(!readonly)  {
		     saved= FALSE;
		     delete_word();
		   }		     
		   break;
   case ' '	  :
   case 33 ... 127:
		   if(!readonly)  {
	             ins_char(ch);
		     saved= 0;
		   }
		   else if(readonly)
		     key_right();
	           break;
   default        :
		   beep();
		   break;
 }
}

bool Data_structure::load(char *name)
{
  FILE *fptr;
  fptr= fopen(name, "r");
  if(!fptr)  return FALSE;
  char c;
  while((c= fgetc(fptr)) != EOF)
    just_ins_char(c);
  initialize();
  compute_bot();
  showtext_scr(text);
  show_rc(statbar);
  fclose(fptr);
  return TRUE;
}

void Data_structure::recreate()
{
  hls.kone=  hls.shuru= new Header;
  line= col= 1;
  currline= hls.shuru;
  saved= FALSE;
  readonly= FALSE;
  hls.no_of_lines= top= bot= s_top= s_bot= 1;
}
   
void Data_structure::unload()
{
  Header *temp=hls.shuru, *temp1= temp;
  for(; temp!=NULL; )  {
    temp1= temp->below;
    delete temp;
    temp= temp1;
   char_count= 0;
   hls.no_of_lines= 0;
  }
}

void Data_structure::initialize()
{
  top= s_top= line= col= 1;
  currline= hls.shuru;
}

void Data_structure::set_readonly()
{
  readonly= TRUE;
}

void Data_structure::reset_readonly()
{
  readonly= FALSE;
}

int Data_structure::no_of_logln(Header *hp)
{
  return ((hp->ptr->last) / (WID) + 1);
}

void Data_structure::inc_dec_re(int t, int s_t, int b, int s_b)
{
  top+= t;
  s_top+= s_t;
  bot+= b;
  s_bot+= s_b;
}

void Data_structure::incre_bot()
{
  if(s_bot == no_of_logln(hls[bot]))  {
    if(bot != hls.no_of_lines)  {
      bot++;
      s_bot= 1;
    }
  }
  else
    s_bot++;
}

void Data_structure::decre_bot()
{
  if(s_bot == 1)  {
    if(bot != 1)  {
      bot--;
      s_bot= no_of_logln(hls[bot]);
    }
  }
  else
    s_bot--;
}

void Data_structure::incre_top()
{
  if(s_top == no_of_logln(hls[top]))  {
    if(top != hls.no_of_lines)  {
      top++;
      s_top= 1;
    }
  }
  else
    s_top++;
}

void Data_structure::decre_top()
{
  if(s_top == 1)  {
    if(top != 1)  {
      top--;
      s_top= no_of_logln(hls[bot]);
    }
  }
  else
    s_top--;
}

int Data_structure::percentage()
{
  return 100*line/hls.no_of_lines;
}

int Data_structure::count_char()
{
  return char_count;
}

int Data_structure::count_word()
{
  int word_count= 0;
  Header *temp= hls.shuru;
  const char *textstr;
  char ch;
  do  {
    textstr= temp->ptr->tx;
    for(int i=0; textstr[i]!='\0'; i++)  {
       ch= textstr[i];
       if(((ch>=32 && ch<=47) || (ch>=58 && ch<=64)
			      || (ch>=91 && ch<=96 || ch>=123 && ch<=126)))
    	  word_count++;
    }
    temp= temp->below;
  } while(temp != NULL);
  
  return word_count;
}

int Data_structure::count_line()
{
  return hls.no_of_lines;
}

int Data_structure::find(int find_or_next, char *key= NULL)
{  
   bool found= false;
   static int oncefound= 0;
   static char *keystr= NULL;
   static Header *temp= hls.shuru;
   static int ln_num= 1, i= 0, j, k, top_num;

   if(find_or_next == 1)  {
      temp= hls.shuru;
      ln_num= 1;
      i= 0;
      keystr= key;
      oncefound= 0;
   }
   if(keystr == NULL || keystr == '\0')  {
      mvwaddstr(statbar, 0, 40, "	Cannot search for empty string");
      statbar_active= true;
      return 0;
   }
   const char *textstr;
   
   for( ; true; temp= temp->below, ln_num++, i=0)  {
      if(temp == NULL )  {
	 if(!oncefound)  {
            mvwaddstr(statbar, 0, 40, "		Cannot find the string");
      	    statbar_active= true;
            return 0;
	 }
	 temp= hls.shuru;
	 ln_num= 1;
	 mvwaddstr(statbar, 0, 40, "Search hit bottom, continuing from top ");
	 statbar_active= true;
	 oncefound= 0;
      }
      for(textstr= temp->ptr->tx; textstr[i]!='\0'; i++)  {
         if(textstr[i] == keystr[0])  {
            for(j=i, k=0; textstr[j]!='\0' && keystr[k]!='\0'; k++, j++)  {
	       if(textstr[j] == keystr[k] && keystr[k+1] == '\0')  {
	          found= true;
	          break;
	       }
   	       else if(textstr[j] != keystr[k])
                  break;
	    }
   	 }
   	 if(found)  {
	    oncefound= 1;
	    line= ln_num;
	    if(line > bot || ln_num < top)
	       top= ln_num;
 	    currline= temp;
 	    col= i+1;
 	    i= j;
 	    s_top= col/WID +1;
 	    compute_bot();
 	    showtext_scr(text);
 	    show_rc(statbar);
 	    show_cursor(text);
	    return 1;
	 }
      }
   }
}
  
void Data_structure::fnd_n_repl(char *str1, char *str2)
{
   char ch= '\0';
   int found= find(1, str1);
   while(found)  {
      mvwaddstr(statbar, 0, 30, "\t\tReplace this occurance Yes/No/All\t");
      showtext_scr(text);
      show_cursor(text);
      show_rc(statbar);
      wrefresh(textwin);
      wrefresh(statbar);
      if(tolower(ch) != 'a')
         ch= wgetch(text);
      if(tolower(ch) == 'y' || tolower(ch) == 'a')  {
         for(int i= 0; str1[i] != '\0'; i++)
	    del_curr_char();
         for(int i= 0; str2[i] != '\0'; i++)
	    process(str2[i]);
      }
      found= find(2);
   }
}
   
int Data_structure::capitalize(int count)
{
   if(count<0) return 0;
   Header* temp= currline;
   char *textstr;
   int i= col-1;
   while(count-- && temp)  {
      textstr= temp->ptr->tx;
      for(; textstr[i] != '\0'; i++)
         textstr[i]= toupper(textstr[i]);
      i= 0;
      temp= temp->below;
   }
}   
	
int Data_structure::lowerize(int count)
{
   if(count<0) return 0;
   Header* temp= currline;
   char *textstr;
   int i= col-1;
   while(count-- && temp)  {
      textstr= temp->ptr->tx;
      for(; textstr[i] != '\0'; i++)
         textstr[i]= tolower(textstr[i]);
      i= 0;
      temp= temp->below;
   }
}   
	
void Data_structure::yank(char *filename, int count)
{
   if(count<0) return;
   FILE *fp= fopen(filename, "w"); 
   if(fp == NULL)
      return;
   Header* temp= currline;
   char *textstr;
   int i= col-1;
   while(count-- && temp)  {
      textstr= temp->ptr->tx;
      for(; textstr[i] != '\0'; i++)
         fputc(textstr[i], fp);
      if(textstr[i] == '\0')
         fputc('\n', fp);
      i= 0;
      temp= temp->below;
   }
   fclose(fp);
}

void Data_structure::cut(char *filename, int count)
{
   if(readonly)
      return;
   if(count<0) return;
   FILE *fp= fopen(filename, "w"); 
   if(fp == NULL)
      return;
   Header* temp= currline;
   char *textstr;
   int i= col-1;
   int ch_count= 0;
   while(count-- && temp)  {
      textstr= temp->ptr->tx;
      for(; textstr[i] != '\0'; i++)  {
	 ch_count++;
         fputc(textstr[i], fp);
      }
      fputc('\n', fp);
      ch_count++;
      i= 0;
      temp= temp->below;
   }
   while(ch_count--)
      del_curr_char();
   saved= false;
   fclose(fp);
}

void Data_structure::paste(char *filename)
{
   FILE *fp= fopen(filename, "r");
   if(fp == NULL)
      return;
   char ch;
   while((ch= fgetc(fp)) != EOF)
      process(ch);
   fclose(fp);
}
   
void Data_structure::key_left()
{
  if(prevc())  {
    if(line == top)  {
      if((col-1)%WID == 0 && (col/WID)+1 == s_top )  {
        s_top--;
        compute_bot();
      }
    }
    move_lft();
  }
  else
    beep();
}

void Data_structure::key_right()
{
  if(nextc())  {
    if(line == bot)  {
      if(col%WID == 0 && (col/WID) == s_bot)  {
        s_bot++;
        compute_top();
      }
    }
    move_rgt();
  }
  else
    beep();
}

void Data_structure::key_up()
{
  if(prevl())  {
    if(top < line-1)  {
      move_up();
      return;
    }
    if(top == line-1)  {
      if(s_top == 1 || (col/WID)+1 >= s_top)  {
	move_up();
	return;
      }
      move_up();
      if(!(col/WID +1 > s_top))		// For the screen to not move up
         s_top= (col/WID)+1;
      compute_bot();
      return;
    }
    if(top == line)  {
      move_up();
      inc_dec_re(-1,0,0,0);
      s_top= (col/WID)+1;
      compute_bot();
    }
    return;
  }
  else if(top == 1 && col != 1)  { 
    s_top= 1;
    col= 1;
    compute_bot();
  }
  else
    beep();
}
	   
void Data_structure::key_down()
{
  if(nextl())  {
    int prevline= line, prevcol= col;
    if(bot > line+1)  {
      move_down();
      return;
    }
    if(bot == line+1)  {
      if(s_bot == no_of_logln(hls[bot]) || (col/WID)+1 <= s_bot)  {
//	move_down();
//	return;
      }
      move_down();
      if(!(col/WID +1 < s_bot))
         s_bot= (col/WID)+1;
      compute_top();
      return;
    }
    if(bot == line)  {
      move_down();
      inc_dec_re(0,0,1,0);
      s_bot= (col/WID)+1;
      compute_top();
    }
    return;
  }
  else if(bot == hls.no_of_lines && col != hls[bot]->ptr->last+1)  { 
    s_bot= no_of_logln(hls[bot]);
    col= hls[bot]->ptr->last+1;
    compute_top();
  }
  else
    beep();
}

void Data_structure::up_one_line()
{
  if(line == top && s_top == col/WID +1)  {
    if(s_top != 1)  {
      col-= WID;
      s_top--;
      compute_bot();
    }
    else
      beep();
  }
  else  if(col - WID >= 1)
    col-= WID;
  else
    beep();
}
    
void Data_structure::down_one_line()
{
  if(line == bot && s_bot == col/WID +1)  {
    if(s_bot != no_of_logln(currline))  {
      col+= WID;
      s_bot++;
      compute_top();
    }
    else
      beep();
  }
  else if(col + WID <= currline->ptr->last+1)
    col+= WID;
  else
    beep();
}
    
int Data_structure::key_enter()
{
  if(line == bot)  {
    if((col/WID)+1 == s_bot)  {
      bot++;
      s_bot= 1;
      return 1;
    }
    else
      return 2;
  }
  else if(line != bot)
     return 2;
} 

int Data_structure::move_rgt()
{
  if(col <= currline->ptr->last)
    return ++col;
  else 
    return 0;
 }

int Data_structure::move_lft()
{
  if(col <= 0)	exit(0);
  if(col > 1)	
    return --col;
  else
    return 0;
 }

int Data_structure::move_up()
{
   Header *prevline= currline;
   if(currline= hls.up(currline))    {
     line--;
     if(col == 1 && col != prevline->ptr->last+1)
       ;
     else if(col == prevline->ptr->last+1 || col > currline->ptr->last)
       col= currline->ptr->last+1;
     return col;
   }
   else  {
     currline= prevline;
     return 0;
    }
  }

int Data_structure::move_down()
{
   Header *prevline= currline;
   if(currline= hls.down(currline))    {
     line++;
     if(col == 1 && col < prevline->ptr->last+1)
       ;
     else if(col == prevline->ptr->last+1 || col > currline->ptr->last)
       col= currline->ptr->last+1;
     return col;
   }
   else  {
     currline= prevline;
     return 0;
    }
  }

int Data_structure::pg_up()
{
  if(top == 1 && s_top == 1)
    return 0;
  bot= line= top;
  currline= hls[line];
  s_bot= s_top;
  col= (s_top-1)*(WID)+1;
  compute_top();
  if(top == 1 && s_top == 1)
    compute_bot();
  return 1;
}

int Data_structure::pg_down()
{
  if(bot == hls.no_of_lines && s_bot == no_of_logln(hls[bot]))
    return 0;
  top= line= bot;
  s_top= s_bot;
  col= (s_bot-1)*(WID)+1;
  currline= hls[line];
  compute_bot();
  if(bot == hls.no_of_lines && s_bot == no_of_logln(hls.kone))  {
    top= bot= hls.no_of_lines;
    s_top= s_bot= no_of_logln(hls.kone);
    line= hls.no_of_lines;
    currline= hls.kone;
  }
  return 1;
}
	
void Data_structure::goto_endl()
{
  col= currline->ptr->last+1;
  if(bot == line)  {
    s_bot= no_of_logln(hls[bot]);
    compute_top();
  }
 }

void Data_structure::goto_homel()
{
  col= 1;
  if(top == line)  {
    s_top= 1;
    compute_bot();
  }
}

void Data_structure::goto_endf()
{
  currline= hls.end();
  col= currline->ptr->last;
 }

void Data_structure::goto_homef()
{
  currline= hls.home();
  col= 1;
  }

int Data_structure::endc()
{
  return currline->ptr->last+1;
 }

int Data_structure::nextc()
{
  if(col == endc())
    return 0;
  else
    return col+1;
 }

int Data_structure::prevc()
{
  if(col == 1)
    return 0;
  else
    return col-1;
 }

int Data_structure::nextl()
{
  if(currline->below)
    return line+1;
  else
    return 0;
 }

int Data_structure::prevl()
{
  if(currline->above)
    return line-1;
  else
    return 0;
 }

bool Data_structure::is_readonly()
{
  return readonly;
}

void Data_structure::ins_char(char ch)
{
  int prevlast= currline->ptr->last;
  int prevcol= col;
  currline->ptr->ins_char_before(ch,col);
  col++;
  char_count++;
  if((currline->ptr->last)/WID - ((prevlast)/WID) > 0)  {
    if(line == bot) 
      s_bot++;
    else if(s_bot == 1)  {
      bot--;
      s_bot= no_of_logln(hls[bot]);
    }
    else
      s_bot--;
    compute_top();
  }
}

void Data_structure::just_ins_char(char ch)
{
  if(ch == '\n')
    ins_ln_at_end();
  else if(ch == '\t')  { 
	           int which;
		   if(col == 1 || col%WID == 0)
		     which= TAB;
		   else
		     which= TAB - col%TAB;
		   for(int i=0; i<=which ; i++)  {
    		     char_count++;
    		     currline->ptr->ins_char_before(' ',col);
		   }
  }
  else  {
    char_count++;
    currline->ptr->ins_char_before(ch,col);
    col++;
  }
}

void Data_structure::del_char()
{
  currline->ptr->del_char(col);
  char_count--;
 }

void Data_structure::delete_word()
{
  char ch;
  do  {
    del_curr_char();
    ch= currline->ptr->tx[col-1];
  }while(!((ch>=32 && ch<=47) || (ch>=58 && ch<=64) || (ch == '\0')
			      || (ch>=91 && ch<=96) || (ch>=123 && ch<=126)));
}

void Data_structure::delete_line()
{
   if(!readonly)  {
     if(nextl() || prevl())  {
       saved= FALSE;
       if(top == line)  {
         if(top == 1)  {
           s_top= 1;
	   char_count-= currline->ptr->last;
           move_down();
           hls.del_pos(currline->above);
	   line--;
           col= 1;
	 }
	 else  {
	   if(nextl())  {
	      currline= currline->below;
	      s_top= 1;
	      char_count-= currline->above->ptr->last;
	      hls.del_pos(currline->above);
	   }
	   else  {
	     move_up();
	     s_top= no_of_logln(currline);
	     char_count-= currline->below->ptr->last;
	     hls.del_pos(currline->below);
	     bot--;
	     compute_top();
	     return;
	   }
	   col= 1;
	 }
       }
       else  {
         col= 1;
         del_ln();
       }
       compute_bot();
     }
     else
	     beep();
   }
}

void Data_structure::del_prev_char()
{ 
  int flag= 0;
  if(move_lft())  {
    if(line == top && col/(WID+1) == 0 && (col/WID)+1 == s_top)  {
      flag= 2;
      decre_top();
    }
    else if(line == top && col/(WID+1) == 0)  {
      incre_bot();
      flag= 1;
    }
    del_char();
  }
  else if(line > 1)  {
    if(top == line && s_top == 1)  {
      decre_top();
      flag= 2;
    }
    else
      flag= 2;
    append_to_prev_ln();
  }
  else
    beep(); 
  if(flag == 1)
    compute_top();
  else
    compute_bot();
 }

void Data_structure::del_curr_char()
{ 
  int flag= 0;
  if(nextc())  {
    flag= 2; 
    del_char();
  }
  else if(nextl())  {
    flag= 2;
    append_next_ln();
  }
  else 
    beep();
  if(flag == 1)
    compute_top();
  else
    compute_bot();
 }
	
void Data_structure::append_next_ln()
{
  int j= endc(), k=j;
  for(int i=0; i<currline->below->ptr->last;i++,j++)
    currline->ptr->ins_char_before(currline->below->ptr->tx[i],j);
  del_next_ln();
  col= k;
 }

void Data_structure::ins_ln_at_home()
{
  hls.ins_before(currline);
  col= 1;
  line++;
 }

void Data_structure::ins_ln_at_end()
{
  hls.ins_after(currline);
  currline= currline->below;
  col= 1;
  line++;
 }

void Data_structure::ins_ln_at_mid()
{
  int j= 1;
  hls.ins_after(currline);
  for(int i=col-1; i<currline->ptr->last;i++,j++)
    currline->below->ptr->ins_char_before(currline->ptr->tx[i],j);
  while(currline->ptr->last != col-1)
    currline->ptr->del_char(col);	  
  currline= currline->below;
  col= 1;
  line++;
 }

void Data_structure::del_ln()
{
  if(nextl())  {
    move_down();
    hls.del_pos(currline->above);
    line--;
   }
  else if(move_up())
    del_last_ln();
  else  {
    ins_ln_at_home();
    del_last_ln();
  }  
}

void Data_structure::del_next_ln()
{
  hls.del_pos(currline->below);
 }

void Data_structure::del_last_ln()
{
  hls.del_pos(currline->below);
 }

void Data_structure::append_to_prev_ln()
{
  int j= currline->above->ptr->last+1 , k=j;
  for(int i=0; i<currline->ptr->last;i++,j++)
    currline->above->ptr->ins_char_before(currline->ptr->tx[i],j);
  line--;
  currline= currline->above;
  col= k;
  del_next_ln();
 }

void Data_structure::compute_bot()
{
  int lines= 0, logln= 0;
  Header *temp= hls[top];
  bot= top;
  s_bot= s_top;
  hls.kone= hls.end();
  if(temp == hls.kone)  {
    int remaining= HGT;
    logln= no_of_logln(temp);
    if(remaining > logln)
      s_bot= logln;
    else
      s_bot= remaining + s_top - 1;
    return;
  }
  while(++lines < HGT)  {
    if(temp == hls.kone)  {
      logln= no_of_logln(temp);
      while(--logln > 0 && lines++ < HGT)  {
	inc_dec_re(0, 0, 0, 1);
      }
      break;
    }
    if(s_bot == no_of_logln(temp))  {
      temp= temp->below;
      inc_dec_re(0, 0, 1, 0);
      s_bot= 1;
    }
    else
      inc_dec_re(0, 0, 0, 1);
  }
}
   
void Data_structure::compute_top()
{
  int lines= 0, logln= 0;
  s_top= s_bot;
  Header *temp= hls[bot], *temp1= temp;
  top= bot;
  if(temp == hls.shuru)  {
    int remaining= HGT;
    logln= no_of_logln(temp);
    if(remaining > logln)
      s_top= 1;
    else
      s_top= s_bot - remaining + 1;
    return;
  }
  while(++lines < HGT)  {
    if(temp == hls.shuru)  {
      logln= no_of_logln(temp);
      while(--logln > 0 && lines++<HGT)  {
	inc_dec_re(0, -1, 0, 0);
      }
      break;
    }
    if(s_top == 1)  {
      temp= temp->above;
//      decre_top();
      inc_dec_re(-1, 0, 0, 0);
      s_top= no_of_logln(temp);
    }
    else
      inc_dec_re(0, -1, 0, 0);
  }
}

bool Data_structure::save(char *fname)
{
  FILE *fptr= fopen(fname, "w");
  if(fptr == NULL)
    return FALSE; 
  Header *temp=hls.shuru;
  for(; temp!=NULL; temp=temp->below)	{
    Node *pn= temp->ptr;
    for(int i=0; i<pn->last; i++)   {
      fputc(pn->tx[i],fptr);
     }
    fputc('\n',fptr);
   }
  fclose(fptr);
  return TRUE;
 }
     
void Data_structure::showtext_scr(WINDOW *win)
{
  werase(win);
  int i, j= 0, x= 0, y= 0;
  bool flag= 0;
  Header *hptr= hls[top];
  if(s_top > 1)
   j= (s_top-1)*(WID);
  for(i= top; i<bot; i++,j=0)  {
    flag++;
    x= 0;
    for(; j <= hptr->ptr->last; j++)  {
      if(x == WID)  {
        x= 0;
        y++;
      }
      if(j == hptr->ptr->last)
	mvwaddch(win,y,x,' ');
      else
        mvwaddch(win, y, x, hptr->ptr->tx[j]);
      x++;
    }
    if(hls.down(hptr)) 
      hptr= hptr->below;
    y++;
  }
  x= 0;
  if(flag)  j= 0;
  for(; y<HGT && hptr->ptr->tx[j]!='\0'; j++)  {
    if(x == WID)  {
      x= 0;
      y++;
    }
    mvwaddch(win, y, x, hptr->ptr->tx[j]);
    x++;
  }
}

void Data_structure::show_rc(WINDOW *win)
{ 
  if(!col) { beep(); system("ls");EX }
    mvwprintw(win, 0, 1, "%4d,%4d", line, col,currline->ptr->last);
}

void Data_structure::show_tb(WINDOW *win)
{
  mvwprintw(win, 0, 40, "%3d %3d, %3d, %3d, %d  %d", top, bot,s_top,
		 				 s_bot, hls.shuru, hls.kone);
}
	
void Data_structure::show_cursor(WINDOW *win)
{
  int width= WID;  int l=0, c;
  Header *hptr= hls[top];
  if(s_top<=0)  EX;
  for(int i= top; i<= line; i++)  {
    if(i == line)  {
      for(int n=1; n <= col; n++)
	if(!((n-1)%WID))
	  l++;
      if(i == top)
	l-= s_top-1;
    }
    else if(i == top)  {
      l= ((hptr->ptr->last)/WID - (s_top - 1)+1);
    }
    else  {
      l+= no_of_logln(hptr);
    }
    if(hls.down(hptr))
      hptr= hptr->below;
  }
  c= (col-1)%width;
//  mvwprintw(win, 10, 40, "%3d, %d  ", l, c);
  wmove(win, l-1, c);
}



