#include"dimens.h"
#include<malloc.h>
#include<string.h>
#include<curses.h>
#include"common.h"

#ifndef __DEFINITIONS_OF_BKEND
#define __DEFINITIONS_OF_BKEND
#define QUANT 25
/************************CLASSNODE  ***************************/                
class Node
{
  private:
	  char *tx;      
          int last;   
	  int size;      
  public:
	  Node()      
	  {      
	    tx= (char *)malloc(QUANT);      
	    last= 0;      
	    size= QUANT;      
	    strcpy(tx,"");      
	   }      

	  Node(char *text,int l)      
	  {        
	    l= l+1;      
	    size= l%QUANT ? (l/QUANT+QUANT) : l/QUANT;      
	    tx= (char *)malloc(size);      
	    strcpy((char *)tx, (char *)text);      
	    last= l-1;      
	   }      
        
	  ~Node()      
	  {      
	    free(tx);      
           }
	  void ins_char_before(char ch,int pos);//Inserts character before pos 
	  void del_char(int pos); // Deletes character at position pos      
   friend class Header;
   friend class Header_list;
   friend class Data_structure;
 };


/********************    CLASS HEADER  ***********************/                  
class Header
{
  private:
          Header *above, *below;
          Node *ptr;
  public :
          Header(Header *a=NULL, Header *b=NULL, Header *c=NULL)
          {
            above= a;
            below= b;
            ptr= new Node;
           }

  ~Header()      
  {      
    delete ptr;      
   }      

   friend class Headerlist;
   friend class Data_structure;
  };


/***********************CLASSHEADERLIST**********************/                       
class Headerlist
{
  private:
          Header *shuru, *kone;
  int no_of_lines;      
  public :
          Headerlist()
          {
	    kone= shuru= new Header;      
	    no_of_lines= 1;      
           }
          void ins_front();
          void ins_after(Header *);
	  void ins_before(Header *);      
          void del_pos(Header *);
          Header* up(Header *);
          Header* down(Header *);
          Header* end();
          Header* home();
	  Header* operator[](int);      
  friend class Data_structure;
 };

/******************	CLASS    DATASTRUCTURE		**********************/

class Data_structure
{
  private:
          int line,col;
          Headerlist hls;
          Header *currline;
 	  bool readonly;    
  	  int top, bot, s_top, s_bot;
	  int char_count;
  public :
          Data_structure()
          {
            line= col= 1;
            currline= hls.shuru;
    	    saved= FALSE;      
	    readonly= FALSE;      
	    top= 1;      
	    bot= 1;      
	    s_top= 1;      
	    s_bot= 1;
	    char_count= 0; 
           }
          void process(chtype ch);
  	  bool load(char *);
  	  bool save(char *);
  	  void unload();
	  void recreate();
  	  void set_readonly();
  	  void reset_readonly();
	  int percentage();
		//  miscellaneous functions
	  int find(int , char* = NULL);	  
	  void fnd_n_repl(char* = NULL, char* =NULL);	  
	  int count_char();
	  int count_word();
	  int count_line();
	  int capitalize(int);
	  int lowerize(int);
	  void yank(char *, int);
	  void cut(char *, int);
	  void paste(char *);
                // Just cursor movement
  	  int move_rgt();
  	  int move_lft();
          int move_up();
          int move_down();
	  void up_one_line();
	  void down_one_line();
          int pg_up();
          int pg_down();
          void goto_endl();
          void goto_homel();
          void goto_endf();
          void goto_homef();
	        // Value generating      
	  int endc();      
	  int nextc();      
	  int prevc();      
	  int nextl();      
	  int prevl();      
	  bool is_readonly();
                // Text processing
	  void ins_char(char);    
	  void just_ins_char(char);      
	  void del_char();      
	  void del_prev_char();      
	  void del_curr_char();      
          void ins_ln_at_home();
          void ins_ln_at_end();
          void ins_ln_at_mid();
	  void append_to_prev_ln();        
	  void append_next_ln();
          void del_last_ln();
          void del_ln();
	  void del_next_ln();      
	  void delete_word();
	  void delete_line();
		// Key corresponding functions      
	  void key_left();      
	  void key_right();      
	  void key_up();      
	  void key_down();      
	  int key_enter();      
		// Display routines         
	  void showtext_scr(WINDOW*);      
	  void showtext_ln();      
	  void show_cursor(WINDOW*);      
	  void show_rc(WINDOW*);      
	  void show_tb(WINDOW*);      
	  void compute_top();      
	  void compute_bot();      
	  int no_of_logln(Header*);      
	  void incre_bot();      
	  void decre_bot();      
	  void incre_top();      
	  void decre_top();      
	  void initialize();      
	  void inc_dec_re(int t, int s_t, int b, int s_b);      
 };

#endif

