#include<curses.h>
#include<stdlib.h>
#include<ctype.h>
#include"dimens.h"
#include"common.h"
#include"defs.h"
#include<unistd.h>
#include<time.h>
#include<math.h>
#include<sys/stat.h>

extern Data_structure d;

extern WINDOW *titlebar, *menubar, *textwin, *text, *statbar;
void open_dialog(int);
char* getname(char *);
bool open_file(char *);
bool is_file_there(char *, int);
bool save_file(char*);
bool can_write_file(char *);
void OS_shell();
bool set_permissions();
void page_setup();
void redra_textwin();
void change_color();
void find_func(int);
void fnd_repl();
int confirm(char *);
void error(char *);
void show_data(int);
void Capitalize();
void lowerize();
int file_save();
void yank();
void cut();
void paste();
void showfile(char *);

int showmenu(char **menuitems,int n,int menu_num)
{
  WINDOW *menu;
  curs_set(FALSE);
  chtype ch= 'f';  int i=1;   
  short select=1;
   menu= newwin(n+2,18,2,((menu_num-1)*18+2));      
//   box(menu,0,0);
   keypad(menu,TRUE);
   wbkgd(menu,COLOR_PAIR(menu_color_pair));
   for(i=1;i<= n;i++)    {
     if(i==1)
       wattrset(menu,A_REVERSE);
        mvwaddstr(menu,i,1,menuitems[i-1]);
        wattroff(menu,A_REVERSE);
     	}
     
      while(ch!=27)   {
          for(i=1;i<= n;i++)   {
            if(i==select)
              wattrset(menu,A_REVERSE);
            mvwaddstr(menu,i,1,menuitems[i-1]);
            wattroff(menu,A_REVERSE);   
          }
           flushinp();
           ch=wgetch(menu);
	   if(isdigit(ch))  {
	     if((ch-'0') <= n && (ch -'0') > 0)  {
	       delwin(menu);
	       curs_set(TRUE);
	       return(ch-'0');
	     }
	     else
	       beep();
	   }
           switch(ch)  {
	      case 10         :
		      		delwin(menu);
				curs_set(TRUE);
				return select;
				break;
              case ESC	     : 
			        delwin(menu);  
				curs_set(TRUE);
                       	        return(0);     break;
              case KEY_UP     : 
                                if(select==1) select= n;
                                else select--;    break;
              case KEY_DOWN   :  
		       	        if(select==n) select= 1;
                                else select++;    break;
	      case CTRL('w')  : 
	                        delwin(menu);
				return(-1);   
	      case CTRL('n')  : 
                                delwin(menu);
				return(-2);
              case CTRL('t')  :
				delwin(menu);
                                return(-3);
              case CTRL('a')  : 
                                delwin(menu);
				return(-4);
              case KEY_LEFT   :
                                if(menu_num != 1)
                                  return(-(menu_num-1));
				else
				  return -4;
	      case KEY_RIGHT  :
			        if(menu_num != 4)
				  return(-(menu_num+1));
				else
				  return -1;
              default         : 
			        beep();   break; 
	      
            }
          }
 }


char changeto(int choice)
{
  switch(choice)  { 
    case -1 :
	     return CTRL('w');
    case -2 :
	     return CTRL('n');
    case -3 :
	     return CTRL('t');
    case -4 :
	     return CTRL('a');
  }
}



void showabout()
{
  WINDOW *about= newwin(10,50,8,20);
  box(about, 0, 0);
  wbkgd(about, COLOR_PAIR(8)|A_BOLD);
  char cool1[]="**         \"abc 2K+1\"                         **";
  char cool2[]="**    cool \"abc 2K+1\"  for           LINUX";
  char cool3[]=" a cooler LINUX    **";
  curs_set(FALSE);
  wmove(about, 1,1);
  for(int i=0; cool1[i]!='\0'; i++)  {
    waddch(about, cool1[i]);
    for(int j= 0; j<1000; j++) wrefresh(about);
    beep();
  }
  wmove(about, 1,1);
  for(int i=0; cool2[i]!='\0'; i++)  {
    waddch(about, cool2[i]);
    for(int j= 0; j<1000; j++) wrefresh(about);
  }
  wmove(about, 1,28);
  for(int i=0; cool3[i]!='\0'; i++)  {
    waddch(about, cool3[i]);
    for(int j= 0; j<1000; j++) wrefresh(about);
  }
  mvwaddstr(about, 2, 1, "________________________________________________");
  wrefresh(about);
  WINDOW *inabout= derwin(about, 6, 45, 3, 1);
  wbkgd(inabout,COLOR_PAIR(9)|A_BOLD);
  mvwaddstr(inabout, 0, 17, "Hi! guys ...");
  mvwaddstr(inabout, 1, 5, " \"abc\" is for YOU.   So,  enjoy it  ...");
  mvwaddstr(inabout, 2, 4, "\"abc\"(c) - Copyright 2001 by Nithin B.R.\n\n   Feedback to");
  curs_set(2);
  char mail[]= "metalnithin@metallica.com";
  wmove(inabout, 5, 16);
  wattrset(inabout,COLOR_PAIR(10)|A_BOLD);
  for(int i=0; mail[i]!='\0'; i++)  {
    waddch(inabout, mail[i]);
    for(int j= 0; j<3000; j++) wrefresh(inabout);
    beep();
  }
  curs_set(FALSE);
  flushinp();
  wgetch(inabout);
  delwin(inabout);
  curs_set(TRUE);
  flushinp();
  return;
 } 

void process(int choice,int menu_num)
{
 int i;
 int flag= 1;
 int permission= 1;
 char name[100];
 char delete_command[100];
 char *nameptr= NULL;
 int yesorno;
 switch(menu_num)   {
   case 1:
           switch(choice)   {
               case 1:
		       flag= 1;
		       if(!named || !saved)  {
			 yesorno= confirm("File not saved, save ?");
			 flag= yesorno;
			 if(yesorno == 1)  {
			   flag= 1;
			   if(!file_save())
			      flag= 0;
			 }
		       }
		       if(flag)  {
			 d.unload();
			 saved= 0;
			 named= 0;
			 strcpy(curr_file_name,"Not_yet_named");
			 d.recreate();
		       }			     
		       break;
	       case 2:
		       flag= 1;
		       if(!named || !saved)  {
			 yesorno= confirm("File not saved, save ?");
			 flag= yesorno;
			 if(yesorno == 1)  {
			   flag= 1;
			   if(!file_save())
			      flag= 0;
			 }
		       }
		       if(flag)  {
			 nameptr= getname("Enter the name of the file");
			 if(is_file_there(nameptr, 3))  {
			   d.unload();
			   strcpy(curr_file_name, nameptr);
			   free(nameptr);
			   d.recreate();
			   saved= 1;
			   named= 1;
			   d.load(curr_file_name);
			 }
			 else
			   error("file open error");
		       }			     
		       break;
	       case 3:
		       flag= 1;
		       if(!named || !saved)  {
			 yesorno= confirm("File not saved, save ?");
			 flag= yesorno;
			 if(yesorno == 1)  {
			   flag= 1;
			   if(!file_save())
			      flag= 0;
			 }
		       }
		       if(flag)  {
			 nameptr= getname("Enter the name of the file");
			 if(is_file_there(nameptr, 2))  {
			   d.unload();
			   strcpy(curr_file_name, nameptr);
			   d.set_readonly();
			   free(nameptr);
			   d.recreate();
			   saved= 1;
			   named= 1;
			   d.load(curr_file_name);
			   d.set_readonly();
			 }
			 else
			   error("file open error");
		       }
		       break;
	       case 4:
		       file_save();
		       break;
	       case 5:
		       nameptr= getname("Enter the name for the file");
		       if(!access(nameptr, F_OK))  {
		          if(confirm("File exists, overwrite") <= 0)
		             return;
		       }
		       else  {
			  d.save(nameptr);
			  strcpy(curr_file_name, nameptr);
			  saved= 1;
			  named= 1;
			  break;
		       }
		       if(is_file_there(nameptr, 3))  {
			 d.save(nameptr);
			 strcpy(curr_file_name, nameptr);
			 saved= 1;
			 named= 1;
		       }
		       else
		         error("file save error");
		       break;
	       case 6:
		       flag= 1;
		       if(!named || !saved)  {
			 yesorno= confirm("File not saved, save ?");
			 flag= yesorno;
			 if(yesorno == 1)  {
			   flag= 1;
			   if(!file_save())
			      flag= 0;
			 }
		       }
		       if(flag)  {
			 d.unload();
			 endwin();
			 unlink("/tmp/abc008.tmp");
			 system("clear");
			 exit(0);
		       }			     
		       break;
	   }
	   break;
   case 2:
           switch(choice)   {
               case 1:
		       OS_shell();
                       break;
               case 2:
		       nameptr= getname("Enter the name of the file");
		       if(!strcmp(nameptr, curr_file_name))  {
			  error("Cannot delete current file");
			  break;
		       }				
	    	       sprintf(delete_command, "rm -f %s", nameptr);
	       	       if(unlink(nameptr) == -1) 
		       	 error("file deletion error");
		       break;
               case 3:
		       set_permissions();
                       break;
               case 4: 
		       page_setup();
                       break;
               case 5:
		       change_color();
                       break;
	       case 6:
		       fnd_repl();
		       break;
	       case 7:
		       find_func(1);
		       break;
	       case 8:
		       find_func(2);
		       break;
             } 
	   break;
   case 3:
           switch(choice)   {
               case 1:
		       show_data(1);
                       break;
               case 2:
		       Capitalize();
                       break;
               case 3:
		       lowerize();
                       break;
               case 4:
		       show_data(2);
                       break;
	       case 5:
		       showfile("Cool cuts");
		       break;
  	       case 6:
		       yank();
		       break;
	       case 7:
		       cut();
		       break;
	       case 8:
		       paste();
		       break;
		
	     }	
	   break;	   
   case 4:
           switch(choice)   {
	       case 1:
		       showfile("Readme.abc");
		       break;
               case 2:
		       showabout();
                       break;
	       case 3:
		       showfile("ABOUT abc.txt");
		       break;
             }
	   break;
      }
   }

bool open_file(char *name)
{
  return(d.load(name));
}

bool is_file_there(char *name, int mode)
{
  if(mode == 1)
     return access(name, F_OK);
  if(access(name, F_OK))
     return 0;
  if(mode == 2)
     return !access(name, R_OK);
  if(mode == 3)
     return !access(name, W_OK);
}

bool can_write_file(char *name)
{
  FILE *fptr= fopen(name, "w");
  if(fptr) fclose(fptr);
  return (fptr ? TRUE : FALSE);
}

bool save_file(char *name)
{
  if(name)
    return d.save(name);
}

int file_save()
{
 char name[100];
 char *nameptr= NULL;

		       if(!named || !saved)  {
			 strcpy(name, curr_file_name);
			 if(!named)  {
			   nameptr= getname("Enter the name for the file");
			   strcpy(name, nameptr);
			   free(nameptr);
			 }
			 if(!named && !access(name, F_OK))  {
			    if(confirm("File exists, overwrite") <= 0)
			       return 0;
			 }
			 else {
			   d.save(name);
			   strcpy(curr_file_name, name);
			   saved= 1;
			   named= 1;
			   return 1;
			 }
 
			 if(!access(name, W_OK))  {
			   d.save(name);
			   strcpy(curr_file_name, name);
			   saved= 1;
			   named= 1;
			   return 1;
			 }
			 else
			   error("file save error");
			 return 0;
		       }
		       else
			       return 1;
}
	
int confirm(char *question)
{
  WINDOW *askwin= newwin(3, 35, 10, 10);
  wbkgd(askwin, COLOR_PAIR(4)|A_BOLD);
  box(askwin, 0, 0);
  echo();
  mvwprintw(askwin, 1, 2, "%s y/n\t", question);
  chtype ch;
  ch= wgetch(askwin);
  delwin(askwin);
  flushinp();
  noecho();
  if(ch == 'y' || ch == 'Y')
    return 1;
  else if(ch == 'n' || ch == 'N')
    return -1;
  else
    return 0;
}

char* getname(char *message)
{
  WINDOW *outer, *inner;
  int pos= 0, last= 0;
  char *name= (char *)malloc(100*sizeof(char));
  chtype ch= 1;
  name[0]= '\0';
  outer= newwin(7, 60, 10, 10); wbkgd(outer, COLOR_PAIR(0)|A_BOLD);
  box(outer, 0, 0);
  mvwaddstr(outer, 1, 5, message);
  keypad(outer, TRUE);
  wrefresh(outer);
  inner= derwin(outer, 3, 56, 3, 2);
  wbkgd(inner, COLOR_PAIR(8)|A_BOLD);
  wmove(inner, 0, 1);
  echo();
  touchwin(inner);
  wrefresh(inner);
  wgetnstr(inner, name, 199);
  delwin(outer);
  flushinp();
  noecho();
  return name; 
}
	
void error(char *message)
{
  WINDOW *errwin= newwin(3, 30, 10, 10);
  wbkgd(errwin, COLOR_PAIR(5)|A_BOLD);
  box(errwin, 0, 0);
  mvwaddstr(errwin, 1, 1, message);
  wrefresh(errwin);
  wgetch(errwin);
  delwin(errwin);
  flushinp();
}

void OS_shell()
{
  char copy[100];
  scr_dump("/tmp/abc007.tmp");
  endwin();
  system("clear");
  system("sh");
  sprintf(copy, "cp -f %s", curr_file_name);
  system(copy);
  scr_restore("/tmp/abc007.tmp");
  unlink("/tmp/abc007.tmp");
  sprintf(copy, "mv -f %s", curr_file_name);
  system(copy);
  doupdate();
}

bool set_permissions()
{
 WINDOW *permwin;
 int permit[][3]= { { 0, 0, 0 },
         	    { 0, 0, 0 },
 		    { 0, 0, 0 } };
 
 permwin= newwin(8, 55, 10, 10);
 wbkgd(permwin, COLOR_PAIR(8)|A_BOLD);
 noecho();
 box(permwin, 0, 0);
 keypad(permwin, TRUE);
 mvwaddstr(permwin, 1, 5, "use SPACE BAR to choose the permissions");
 mvwaddstr(permwin, 2, 5, "use TAB to navigate");
 wattron(permwin, COLOR_PAIR(9)|A_BOLD);
 mvwaddstr(permwin, 4, 3, "USER :    read [ ]     write [ ]      exec [ ]");
 mvwaddstr(permwin, 5, 3, "GROUP:    read [ ]     write [ ]      exec [ ]");
 mvwaddstr(permwin, 6, 3, "ALL  :    read [ ]     write [ ]      exec [ ]");
 wattroff(permwin, COLOR_PAIR(9)|A_BOLD);
 chtype ch;
 int px= 0, py= 0;
 int x, y;
 do  {
   y= py + 4;
   x= px*14 + 19;
   wmove(permwin, y, x); 
   ch= wgetch(permwin);
   switch(ch)  {
     case ESC  :
	     	delwin(permwin);
		return FALSE;
		break;
     case ' '  :
		if(permit[py][px])  {
	          permit[py][px]= 0;
		  mvwaddch(permwin, y, x, ' ');
		}
		else  {
		  wattron(permwin, COLOR_PAIR(10)|A_BOLD);
		  permit[py][px]= 1;	
		  mvwaddch(permwin, y, x, '*');
		  wattroff(permwin, COLOR_PAIR(10)|A_BOLD);
		}
     case '\t' :
	        if(px == 2)  {
		  px= 0;
		  if(py == 2)  py= 0;
		  else  py++;
		}
		else  px++;
		break;
     default   :
		beep();
		break;
   }
 }while(ch != 10);
 wrefresh(permwin);
// chmod();
  int perm= 0, s;
  for(int i=0; i<3; i++){
     s= 0;
     for(int j=0; j<3; j++)
        if(permit[i][j]) s+= 1<<(2-j);
     perm += pow(8,(2-i))*s;
  }
  if(!named)
     error("File not saved");
  else  {
     if(chmod(curr_file_name, perm))
	error("permission error");
  }
}

void page_setup()
{
  WINDOW *setupwin= newwin(12, 30, 10, 10);
  keypad(setupwin, TRUE);
  box(setupwin, 0, 0);
  wbkgd(setupwin, COLOR_PAIR(8)|A_BOLD);
  mvwaddstr(setupwin, 1, 1, "You can set the margins here");
  mvwaddstr(setupwin, 2, 1, "use KEY UP and KEY DOWN");
  wattron(setupwin, COLOR_PAIR(9)|A_BOLD);
  mvwaddstr(setupwin, 4, 3, "Top margin        [  ]");
  mvwaddstr(setupwin, 5, 3, "Bottom margin     [  ]");
  mvwaddstr(setupwin, 6, 3, "Left margin       [  ]");
  mvwaddstr(setupwin, 7, 3, "Right margin      [  ]");
  wattroff(setupwin, COLOR_PAIR(7)|A_BOLD);
  mvwaddstr(setupwin, 9, 2, "(r)Reset to defaults");
  wattron(setupwin, COLOR_PAIR(10)|A_BOLD);
  int values[4]= { T_m, B_m, L_m, R_m };
  int px= 0, py =0, x= 0, y= 0;
  chtype ch;
  do  {
    for(int i=0; i<4; i++)   {
      mvwprintw(setupwin, 4+i, 22, "%2d", values[i]);
      mvwprintw(setupwin, 0, 2, "%2d", py);
    }
    y= py + 4;
    x= 23;
    wmove(setupwin, y, x);
    ch= wgetch(setupwin);
    switch(ch)  {
      case ESC		:
	      		 delwin(setupwin);
			 return;
      case '\t'   	:
	      		 if(py == 3)  py= 0;
			 else py++;
			 break;
      case KEY_UP	:
			 if(py <= 1)  {
			   if(py%2)  {
			     if(values[py] + values[py-1] >= 19)   beep();
			     else  values[py]++;
			   }
			   else  {
			     if(values[py] + values[py+1] >= 19)   beep();
			     else  values[py]++;
			   }
			 }
			 else  {
			   if(py%2)  {
			     if(values[py] + values[py-1] >= 77)   beep();
			     else  values[py]++;
			   }
			   else  {
			     if(values[py] + values[py+1] >= 77)   beep();
			     else  values[py]++;
			   }
			 }
			 break;
      case KEY_DOWN	:
			 if(values[py] > 0)  values[py]--;
			 else  beep();
			 break; 
      case 'r'		:
      case 'R'		:
			 values[0]= values[1]= values[2]= values[3]= 0;
			 break;
      default		:
			 beep();
    }
  }while(ch != 10);
  delwin(setupwin);
  T_m= values[0];
  B_m= values[1];
  L_m= values[2];
  R_m= values[3];
  redra_textwin();
}

void change_color()
{
  WINDOW *colorwin;
  colorwin= newwin(14, 40, 10, 20);
  wbkgd(colorwin, COLOR_PAIR(8));
  keypad(colorwin, TRUE);
  box(colorwin, 0, 0);
  mvwaddstr(colorwin, 1, 1, "COLORS");
  mvwaddstr(colorwin, 2, 18, "OBJECTS");
  wattron(colorwin, COLOR_PAIR(9));
  mvwaddstr(colorwin, 2, 3, "0 - BLACK");
  mvwaddstr(colorwin, 3, 3, "1 - RED  ");
  mvwaddstr(colorwin, 4, 3, "2 - GREEN");
  mvwaddstr(colorwin, 5, 3, "3 - YELLOW");
  mvwaddstr(colorwin, 6, 3, "4 - BLUE");
  mvwaddstr(colorwin, 7, 3, "5 - MAGENTA");
  mvwaddstr(colorwin, 8, 3, "6 - CYAN");
  mvwaddstr(colorwin, 9, 3, "7 - WHITE");
  mvwaddstr(colorwin, 3, 20, "1 - MENU");
  mvwaddstr(colorwin, 4, 20, "2 - TEXT WINDOW");
  mvwaddstr(colorwin, 5, 20, "3 - STATUS BAR");
  wattroff(colorwin, COLOR_PAIR(9));
  wattron(colorwin, COLOR_PAIR(10)|A_BOLD);
  mvwaddstr(colorwin, 11, 5, "OBJECT [ ]       FOREGROUND [ ]");
  mvwaddstr(colorwin, 12, 22, "BACKGROUND [ ]");
  wattroff(colorwin, COLOR_PAIR(10)|A_BOLD);
  wattron(colorwin, COLOR_PAIR(9)|A_BOLD);
  chtype ch;
  int obj= -1, foregnd= -1, backgnd= -1;
  int which= 1;
  int y, x;
  do  {
    if(which == 1)  {
      x= 13;
      y= 11;
    }
    else if(which == 2)  {
      x= 34;
      y= 11;
    }
    else  {
      x= 34;
      y= 12;
    }
    wmove(colorwin, y, x);
    ch= wgetch(colorwin);
    if(ch == '\t')  {
      if(which == 1)
        which= 2;
      else if(which == 2)
        which= 3;
      else if(which == 3)
        which= 1;
    }
    else if(ch == ESC)  {
      delwin(colorwin);
      return;
    }
    else if(which == 1)  {
      if(ch >= '1' && ch <= '3')  {
	waddch(colorwin, ch);
	obj= ch - '0';	
	which= 2;
      }
      else  beep();
    }
    else if(which == 2)  {
      if(ch >= '0' && ch <= '7')  {
	waddch(colorwin, ch);
	foregnd= ch - '0';
	which= 3;
      }
      else  beep();
    }
    else if(which == 3)  {
      if(ch >= '0' && ch <= '7')  {
	waddch(colorwin, ch);
	backgnd= ch - '0';	
	which= 3;
      }
      else  beep();
    }
    else beep();
    
  }while(ch != 10);

  wattroff(colorwin, COLOR_PAIR(9)|A_BOLD);
  delwin(colorwin);
  if(obj != -1 && foregnd != -1 && backgnd != -1)  {
    init_pair(obj, foregnd, backgnd);
    if(obj == 1)
      ;
    else if(obj == 2)  {
      wbkgd(textwin, COLOR_PAIR(textwin_color_pair)|A_BOLD);
      wbkgd(text, COLOR_PAIR(textwin_color_pair)|A_BOLD);
      wrefresh(textwin);
    }
    else if(obj == 3)  {
      wbkgd(statbar, COLOR_PAIR(statusbar_color_pair)|A_BOLD);
      wrefresh(statbar);
    }
  }
}  

void find_func(int find_or_next)
{
  if(find_or_next == 1)
     d.find(1, getname("Enter the string ..."));
  else
     d.find(2);
}

void fnd_repl()
{
   d.fnd_n_repl(getname("Enter the string to search"), getname("Enter the replace string"));
}
		   
void show_data(int data_num)
{
  char message[20];
  WINDOW *datawin= newwin(7, 40, 10, 10);
  wbkgd(datawin, COLOR_PAIR(9)|A_BOLD);
  box(datawin, 0, 0);
  curs_set(FALSE);
  int c_count= d.count_char(),
      w_count= d.count_word(),
      l_count= d.count_line();
  time_t cal;
  switch(data_num)  {
     case 1	:
  		 time(&cal);
		 mvwprintw(datawin, 4, 5, "%s", ctime(&cal));
  		 box(datawin, 0, 0);
		 break;
     case 2	:
		 for(int i=0; i<= c_count; i++)  {
		    mvwprintw(datawin, 2, 5, "Character count------>%6d", i);
		    for(int j=0; j<= 10; j++)
		       wrefresh(datawin);
		 }
		 for(int i=0; i<= w_count; i++)  {
		    mvwprintw(datawin, 3, 5, "Word count----------->%6d", i);
		    for(int j=0; j<= 10; j++)
		       wrefresh(datawin);
		 }
		 for(int i=0; i<= l_count; i++)  {
		    mvwprintw(datawin, 4, 5, "Line count----------->%6d", i);
		    for(int j=0; j<= 100; j++)
		       wrefresh(datawin);
		 }
		 break;
  }
  wrefresh(datawin);
  wgetch(datawin);
  delwin(datawin);
  flushinp();
  curs_set(TRUE);
}

void Capitalize()
{
   int count= atoi(getname("Enter the no of lines to capitalize"));
   d.capitalize(count);
}

void lowerize()
{
   int count= atoi(getname("Enter the no of lines to capitalize"));  
   d.lowerize(5);
}

void yank()
{
   d.yank("/tmp/abc008.tmp", atoi(getname("Enter the no. of lines to yank")));
}

void cut()
{
   d.cut("/tmp/abc008.tmp", atoi(getname("Enter the no. of lines to yank")));
}

void paste()
{
   d.paste("/tmp/abc008.tmp");
}

void showfile(char *name)
{
  WINDOW *win= newwin(25, 80, 0, 0);
  wbkgd(win, COLOR_PAIR(8)|A_BOLD);
  FILE *fp= fopen(name, "r");
  char ch;
  if(fp != NULL)
  while((ch= fgetc(fp)) != EOF)
     waddch(win, ch);
  wrefresh(win);
  wgetch(win);
  flushinp();
  delwin(win);
  fclose(fp);
}
