#include <curses.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <panel.h>
#include <string>
#include <list>


#define LINE_LENGTH 255		/* Maximum length of a line. */
#define TAB_SPACING 5		/* Number of characters per tab. */

struct line
  {				/* The storage for the text. */
    char *content;
    int number;
    struct line *next;
  };
struct yank {
	char content[LINE_LENGTH];
};

typedef struct line rad;

char *filemenu[]={" NEW          "," OPEN         "," SAVE         "," SAVE AS      "," DELETE       "," EXIT         "};
 char *editmenu[]={" DELETE LINE  "," DELETE WORD  "," DELETE EOL   "," DEL `n' LINES"," INS WORD      "," INS LN ABOVE "," INS LN BELOW "," GOTO LINE    "," GOTO BOF     "," GOTO EOF     "};
 char *yankmenu[]={" ESC nDD (cut)"," ESC nYY (sel)"," ESC P (paste)"};
  char *docmenu[]={" LR MARGIN    "," TB MARGIN    "," NEXT LOOK   "," TOUCH SHELL  "};
  char *searchmenu[]={" FIND         "," FIND AGAIN  "," FIND REPLACE "};        
   char *helpmenu[]={" SHORTS CUTS  "," YANK HELP    "," ABOUT        "};
   
static void finish (int sig);
void clean_up (void);
void push_numbers (int line_number);
void add_line (char *buffer, int line_number);
void modify_line (char *buffer, int line_number);
void del_line (int line_number);
char *get_line (int line_number);
void show_list (int top_line, int MIN_COLS, int y, int x);
int save_file (char *file_name);
int load_file (char *file_name, int *lines);
int del_files(char file_names[]);
int get_lineno(int lines);
int get_rightleft();
int get_topbot();
void adjust_list(int& );
int search(char *sword,int& line_number,int& x_pos,int flag); 
int search_exact(char *sword,int& line_number,int& x_pos,int findagain);


rad *head = NULL;		/* The head pointer for the linked list. */
WINDOW *win,*menu,*left,*right,*bottom,*top;
PANEL *pan,*pside,*pmnu;
int maxx,maxy,MAX_LINES,MAX_COLS;
int leftmar,rightmar,topmar;
short int started=0,some=0;
char yank_count=0;
yank yanknode; 
list<yank> Y;
int yankflag=0;
int search_flag=0;
int search_count=0;
#include "process.h"
#include "file_handle.h"
#include "menu.h"

main (int argc, char *argv[])
{
  int count = 0, count2 = 0, count3 = 0,  x;
  int line_number = 0, x_pos,lines = 0, *lines_p = &lines; 
  int top_line ,y_pos,y,MIN_COLS;
  int save_err = 0, load_err = 0, geek=0;
  char buffer[LINE_LENGTH + 1], temp_buffer[LINE_LENGTH + 1];
  char file_name[257]; 
  char dum_buffer[257],dum2_buffer[257],p_buffer[257]; 
  int dumc=0,oldpos,firsttime,is_in_between,isend,addnum;
  
  for (count = 0; count < LINE_LENGTH; count++){
    temp_buffer[count] = file_name[count]=buffer[count] = '\0';
    dum_buffer[count]=dum2_buffer[count]=p_buffer[count]='\0';
  }
  for (count = 0; count < 256; count++)
    file_name[count] = '\0';

  (void) signal (SIGINT, finish); /* arrange interrupts to terminate */

  (void) initscr ();
   start_color();                /* initialize the curses library */
   cbreak(); noecho();
  raw(); 
   getmaxyx(stdscr,maxy,maxx);
   set_maxlines_maxcols(maxy,maxx);
  
   x_pos=x=leftmar; MIN_COLS=leftmar;
   y_pos=y=topmar; top_line=topmar;

   init_pair(1,COLOR_RED,COLOR_BLACK);
   init_pair(3,COLOR_RED,COLOR_BLUE); 
   win=newwin(maxy-3,maxx-2,2,1);
   init_pair(2,COLOR_BLUE,COLOR_BLACK);
   init_pair(6,COLOR_WHITE,COLOR_BLACK);
   wbkgd(win,COLOR_PAIR(2));
   pan=new_panel(win);
   keypad(win,TRUE);
   wrefresh(win);
   draw();		  /* to clear the screen */
/* This is the main loop, which lets you input characters, and processes
 * them in a more or less appropriate way. */
 int i; 
 int c=20; 
 int save_count=0;
 wmove(win,topmar,leftmar);
while (1){
      c=wgetch (win);		/* accept single key as input */
      getyx(win,y,x);		/* Get cursor coordinates */
back: switch (c){
		 case 6 :
		         i=showmenu(filemenu,6,1,c);
			 if (i==0)  goto back;
			  if(i==5) {
                                if (strlen(file_name)==0) i=1;
				else {
				  int loh=del_files(file_name);
				  i=1;
				}
			  }
			 if(i==6){
			           if (started==0) {
					  endwin();
					  system("clear");
					  exit(0);
				  }
				  int j=exit_editor();
				   if(j==1)
			          {
				   endwin();
			           system("clear");
			           exit(0);
			           }
			           		
			   }

			  if(i==2)
			  {
			    new_file();
			    mvwprintw(top,0,1," Anj edit           ");
			     wrefresh(top);
			     head=NULL;
			    for(int j=0;j<=strlen(buffer);j++)
			     buffer[j]='\0';
		top_line=y=topmar;MIN_COLS=leftmar;x=leftmar;y_pos=topmar;
			  line_number=0;lines=0;
			  save_count=0;
			  x_pos=leftmar;
			  lines=0;
			  wclrtobot(win);
        mvwprintw(bottom,0,2," Menu selection: <Ctrl> [feoh]      ");
        mvwprintw(bottom,0,maxx-30," INS Line:1 Col:%d ",leftmar+1);
                          wrefresh(bottom);
                          werase(win);
                          wmove(win,topmar,leftmar);
			 wrefresh(win); 
			 started=0;
				  
				  wmove(win,topmar,leftmar);
				  getyx(win,y,x);
		                  int j=load_a_file(file_name,lines_p);
			          if(j==-1)
				  {i=1; wmove(win,y,x_pos-MIN_COLS+leftmar);}
			          else
				   {
					  y=topmar;
                                          x=x_pos=leftmar;y_pos=topmar;
					  top_line=topmar;MIN_COLS=leftmar;
					  line_number=0;
				          strcpy(buffer,get_line(0));
				          show_list(top_line,MIN_COLS,y,x);
				          wmove(win,y,x_pos-MIN_COLS+leftmar);
				          wrefresh(win);  
				   }
		                   save_count=1;
				   started=1;		  
			  }

			  if(i==3)
			  {
				  if(line_number>=lines)
				  {
					  add_line(buffer,line_number);
					   lines++;
				  }
				  else
					  modify_line(buffer,line_number);

				  if(save_count==1)
				  {
					  
					  int j=save_file(file_name);
				  }
				  else
				  {  
					  save_count=1;
					  save_as(file_name);
					  int j=save_file(file_name);
                 	     mvwprintw(top,0,1," file: %s         ",file_name);
			     wrefresh(top);
				  }
				  started=0;
			  }
			  if(i==4)
			  {
				  char temp_filename[255];
				   if(line_number>=lines)
				 {
				  add_line(buffer,line_number);
				   lines++;
				 }
				 else
				 modify_line(buffer,line_number);
				 save_as(temp_filename);
  				 int j=save_file(temp_filename);
				 strcpy(file_name,temp_filename);
                 	     mvwprintw(top,0,1," file: %s         ",file_name);
			     wrefresh(top);started=0;
			  }
			  if(i==1)
			  {       
				  new_file();
				  mvwprintw(top,0,1," Anj edit           ");
				  wrefresh(top);
				  head=NULL;
				  for(int j=0;j<=strlen(buffer);j++)
					  buffer[j]='\0';
		top_line=y=topmar;MIN_COLS=leftmar;x=leftmar;y_pos=topmar;
				  line_number=0;lines=0;
				  save_count=0;
				  x_pos=leftmar;
				  lines=0;
				  wclrtobot(win);
        mvwprintw(bottom,0,2," Menu selection: <Ctrl> [feyoah]      ");
        mvwprintw(bottom,0,maxx-30," INS Line:1 Col:%d ",leftmar+1);
                                  wrefresh(bottom);
                                  werase(win);
                                  wmove(win,topmar,leftmar);
				  wrefresh(win); 
				  started=0;
				  continue;
			  }
		       break;
           case 5 :
	       i=showmenu(editmenu,10,2,c);
	       if (i==0) goto back;
	       if(i==1) //delete a line
			       goto line_del;
	       if(i==2) //delete a word 
			       goto word_del;
	       if (i==3) // delete up to end of line
		       goto end_del;
	       if (i==4) { //delete n lines
                int num=get_no_of_lines();
	        if (num==-1) break;
	        if (lines==line_number) {
		    add_line(buffer,line_number);
		    lines++;
	        }
                else modify_line(buffer,line_number);
		    rad *p=head;
		    while (p->number != line_number) p=p->next;
		  for (count=0; count<num && p!=NULL; count++) p=p->next;
		   for (int k=1; k<=count; k++) {
			   del_line(line_number); lines--;
		   }
		   buffer[0]='\0';
		   if (lines!=0) {
		    if (line_number>=lines) {
		     strcpy(buffer,get_line(--line_number));
		     y_pos--;
		     if (y==topmar) top_line--;
		    }
		    else
		     strcpy(buffer,get_line(line_number));
		   }
		   x_pos=MIN_COLS=leftmar;
		   break;
	       }
               
	       if (i==5) { //insert a word
		temp_buffer[0]='\0';
		int k=get_word(temp_buffer,"ENTER THE WORD"); if(k==-1) break;
		int temppos=x_pos;
	     for (count = strlen (buffer) + 1; count > x_pos-leftmar; count--)
		buffer[count+k+1] = buffer[count -1];
	      buffer[x_pos-leftmar] = ' '; x_pos++;
		for (int p=0; p<k; p++) {
	         buffer[x_pos-leftmar] = temp_buffer[p]; x_pos++;
		}
	      buffer[x_pos-leftmar] = ' '; 
	      x_pos=temppos;
		  break;
	       }
			
	       if (i==6) { //insert an empty line above
		       if (lines==line_number) {
			       add_line(buffer,line_number);
			       lines++;
		       }
		       else modify_line(buffer,line_number);
		       push_numbers(line_number);
		       buffer[0]='\n'; buffer[1]='\0';
		       add_line(buffer,line_number);
		       lines++;
		       x_pos=MIN_COLS=leftmar;
	       }
	       
	       if (i==7) { //insert an empty line below
		       if (lines==line_number) {
			       add_line(buffer,line_number);
			       lines++;
		       }
		       else modify_line(buffer,line_number);
		       buffer[0]='\n'; buffer[1]='\0';
		       if (line_number==lines-1) {
			       line_number++;
			       add_line(buffer,line_number);
		       }
		       else {
		        push_numbers(line_number+1);
			line_number++;beep();
		       add_line(buffer,line_number);
		       lines++;
		       }
		       x_pos=MIN_COLS=leftmar;
		       y_pos++;
		       if (y_pos==MAX_LINES-1) top_line++;
	       }
	       
	              int num;
	              if (i==9) { //goto beginning of file 
			      num=1;
			      goto del_line;
		      }
		      if (i==10) { //goto end of file
			      num=lines;
			      goto del_line;
		      }
			       
		       if(i==8) { //goto line
			       num=get_lineno(lines);
			       if (num==-1) break;
              del_line:	 if (lines==line_number) {
			  add_line(buffer,line_number);
		          lines++;
			 }
			 else modify_line(buffer,line_number);
		     	 line_number=num-1;
                        x_pos=leftmar; 
		top_line=line_number-line_number%(MAX_LINES-topmar)+topmar;
			y_pos=line_number+topmar; 
                   for (count=0; count<LINE_LENGTH; count++) buffer[count]='\0';
                      strcpy(buffer,get_line(line_number));
		       }
		      break;
         case 15 :
	      i=showmenu(docmenu,4,4,c);
              if (i==0) goto back;
	       if(i==1){
		 int dum=get_leftright();
	         if (dum==-1) break;
		 if (started==0) {
                 x_pos=x=leftmar; MIN_COLS=leftmar;
                 y_pos=y=topmar; top_line=topmar;
	         line_number=0;  break;
		 }
			 
		 if (lines==line_number) {
			 add_line(buffer,line_number);
			 lines++;
		 }
		 else modify_line(buffer,line_number);
	         adjust_list(lines);
		 
                 x_pos=x=leftmar; MIN_COLS=leftmar;
                 y_pos=y=topmar; top_line=topmar;
	         line_number=0; 
		 for (count=0; count<LINE_LENGTH; count++)
			 buffer[count]='\0';
		 strcpy(buffer,get_line(0));
		 
	       }
	       if (i==2) {
		 int dum=get_topbot();
	         if (dum==-1) break;
		 if (lines==line_number) { 
			 add_line(buffer,line_number); lines++;
		 }
		 else modify_line(buffer,line_number);
		 x_pos=leftmar; line_number=0;
		 top_line=topmar; y_pos=topmar;
		 MIN_COLS=leftmar;
		 for (count=0; count<LINE_LENGTH; count++)
			 buffer[count]='\0';
		 strcpy(buffer,get_line(0));
		 break;
	       }
	      if(i==3)
		      change_color();
	      if (i==4) change_shell(); 
	      break;
	case 8 :
		 i=showmenu(helpmenu,3,6,c);
		 if (i==0) goto back;
		 if(i==3)
			 about_window();
		 if (i==1) short_cuts(); 
		 if (i==2) yank_help();
	     	 break;
	 case 1: 
		 i=showmenu(searchmenu,3,5,c);
		 if (i==0) goto back;
		 if (i==1) {
			 temp_buffer[0]='\0';
			 int k=get_word(temp_buffer,"ENTER SEARCH WORD");
			 if (k==-1) break;
			 if (lines==line_number) {
				 add_line(buffer,line_number);
				 lines++;
			 }
			 else modify_line(buffer,line_number);
			 k=search(temp_buffer,line_number,x_pos,0);
			 if (k==0) { disp_search_not(); break; } 
			 search_flag=1;
			 buffer[0]='\0';
			 strcpy(buffer,get_line(line_number));
	                 if ((x_pos) > (MIN_COLS + (MAX_COLS - 1)-leftmar))
                          MIN_COLS = x_pos - (MAX_COLS - 1) +leftmar;
		top_line=line_number-line_number%(MAX_LINES-topmar)+topmar;
			y_pos=line_number+topmar; 
			 break;
		 }
		 if (i==2) {
			 if (search_flag==0) break;
			 int k=search(temp_buffer,line_number,x_pos,1);
			 if (k==0 && search_flag!=0) {
				 int q=disp_s_fromup();
				 if (q==0) { search_flag=0; break;}
				 else 
		                  k=search(temp_buffer,line_number,x_pos,0);
			 }
			 else search_flag=1;
			 buffer[0]='\0';
			 strcpy(buffer,get_line(line_number));
			 
	                 if ((x_pos) > (MIN_COLS + (MAX_COLS - 1)-leftmar))
                          MIN_COLS = x_pos - (MAX_COLS - 1) +leftmar;
		top_line=line_number-line_number%(MAX_LINES-topmar)+topmar;
			y_pos=line_number+topmar;
		       break;
		 }	      
             if (i==3) {
		 temp_buffer[0]='\0';
		 int k=get_word(temp_buffer,"ENTER SEARCH WORD");
		 if (k==-1) break;
		 char repl_word[50]; repl_word[0]='\0';
		  k=get_word(repl_word,"ENTER REPLACE WORD");
		 if (k==-1) break;
		 if (lines==line_number) {
			 add_line(buffer,line_number);
			 lines++;
		 }
		 else modify_line(buffer,line_number);
		 line_number=0; x_pos=leftmar;
repeat_repl:	 if (search_count==0) 
			 k=search_exact(temp_buffer,line_number,x_pos,0);
		 else 
			 k=search_exact(temp_buffer,line_number,x_pos,1);
		 if (k==0) { 
			 if (search_count==0) disp_search_not(); 
			 else disp_searchcount(search_count);
			 search_count=0;
			 break; 
		 }
         	 buffer[0]='\0';
		 strcpy(buffer,get_line(line_number));
                 if ((x_pos) > (MIN_COLS + (MAX_COLS - 1)-leftmar))
                    MIN_COLS = x_pos - (MAX_COLS - 1) +leftmar;
           	 top_line=line_number-line_number%(MAX_LINES-topmar)+topmar;
	         y_pos=line_number+topmar; 
                 show_list(top_line, MIN_COLS, y, x);
                 wmove (win,y_pos-top_line+topmar, leftmar);
                 wclrtoeol (win);
                 wattron(win,A_BOLD);
      for (count = MIN_COLS; count < (MIN_COLS + (MAX_COLS - 1)-leftmar) && 
	     (count < strlen(buffer)+leftmar); count++)
	{ 
	  if (buffer[count-leftmar] == '\t')
	    waddch(win,' ');
	  else
	    waddch(win,buffer[count-leftmar]);
	} 
		 wattron(win,A_BLINK);
                 wmove(win,y_pos-top_line+topmar, x_pos-MIN_COLS+leftmar);
		 waddch(win,buffer[x_pos-leftmar]);
		 wrefresh(win);
                 wattroff(win,A_BOLD);
		 wattroff(win,A_BLINK); wrefresh(win);
		 int q=repl_all_single();
		while (q==1 || q==2) {
			search_count++;
                  //delete the word
	    for (int j=strlen(buffer); j<LINE_LENGTH; j++) buffer[j]='\0';
	    count=x_pos-leftmar;
	    if (buffer[count]=='\0') break;
	    if (buffer[count]==' '|| buffer[count]=='\t') break;
	    while (buffer[count]!=' ') {
		    count--;if (count==-1) break;
	    }
	    count2=count+1;
	    count=x_pos-leftmar;
	    while (buffer[count]!='\t'&&buffer[count]!=' ') {
		    count++;if (buffer[count]=='\0') break;
	    }
	    count++;
	    while (buffer[count]==' '||buffer[count]=='\t') count++;
	    count3=LINE_LENGTH-(count-count2);
	    for (int j=count2; j<count3;  j++){
		    buffer[j]=buffer[j+(count-count2)];
	    }
	    x_pos=count2+leftmar;
	    for (int j=strlen(buffer); j<LINE_LENGTH; j++) buffer[j]='\0';
	//word deleted
	    //replace word		 
		int temppos=x_pos; k=strlen(repl_word);
	     for (count = strlen (buffer) + 1; count > x_pos-leftmar; count--)
		buffer[count+k] = buffer[count -1];
		for (int p=0; p<k; p++) {
	         buffer[x_pos-leftmar] = repl_word[p]; x_pos++;
		}
	      buffer[x_pos-leftmar] = ' '; 
	      x_pos=temppos; 
	//word replaced	 
	      
	      modify_line(buffer,line_number);     
	      
	      if (q==1) {
                 show_list(top_line, MIN_COLS, y, x);
                 wmove (win,y_pos-top_line+topmar, leftmar);
                 wclrtoeol (win);
                 wattron(win,A_BOLD);
      for (count = MIN_COLS; count < (MIN_COLS + (MAX_COLS - 1)-leftmar) && 
	     (count < strlen(buffer)+leftmar); count++)
	{ 
	  if (buffer[count-leftmar] == '\t')
	    waddch(win,' ');
	  else
	    waddch(win,buffer[count-leftmar]);
	} 
                 wmove(win,y_pos-top_line+topmar, x_pos-MIN_COLS+leftmar);
		 waddch(win,buffer[x_pos-leftmar]);
                 wattroff(win,A_BOLD);
		 wrefresh(win);
		      goto repeat_repl;
	      }
	          
	      k=search_exact(temp_buffer,line_number,x_pos,1);
	      if (k==0) {
		      wrefresh(win); 
		      disp_searchcount(search_count);
		       search_count=0;
		      break;
	      }
			 buffer[0]='\0';
			 strcpy(buffer,get_line(line_number));
	                 if ((x_pos) > (MIN_COLS + (MAX_COLS - 1)-leftmar))
                          MIN_COLS = x_pos - (MAX_COLS - 1) +leftmar;
		top_line=line_number-line_number%(MAX_LINES-topmar)+topmar;
			y_pos=line_number+topmar; 
	     }
	     break;
      }
		 
		 break;
		 
   case 25:
	      i=showmenu(yankmenu,3,3,c); 
              if (i==0) goto back;
	     if (i==1) {
yank_cut:	    int num=get_no_of_lines();
		    if (num==-1) break;
		    if (lines==line_number) {
			    add_line(buffer,line_number);
			    lines++;
		    }
		    else modify_line(buffer,line_number);
		    rad *p=head;
		    while (p->number != line_number) p=p->next;
		    if (yankflag==1) {
			    list<yank>::iterator it=Y.begin();
			    while (it!=Y.end()) {
				    Y.erase(it);
				    it=Y.begin();
			    }
			    yankflag=0;
		    }
		  for (yank_count=0; yank_count<num && p!=NULL; yank_count++) {
			    strcpy(yanknode.content,p->content);
			    Y.push_back(yanknode);
			    beep();
			    p=p->next;
		  }
		  yankflag=1;
        mvwprintw(top,0,45,"                 ",yank_count);
        mvwprintw(top,0,55," %d lines yanked     ",yank_count);
	wrefresh(top);
		  
		   for (int k=1; k<=yank_count; k++) {
			   del_line(line_number); lines--;
		   }
		   buffer[0]='\0';
		   if (lines!=0) {
			   
		   if (line_number>=lines) {
		     strcpy(buffer,get_line(--line_number));
		     y_pos--;
		     if (y==topmar) top_line--;
		   }
		   else
			    strcpy(buffer,get_line(line_number));
		   }
		   x_pos=MIN_COLS=leftmar;
		   break;
	     }
	     if (i==2) {
yank_sel:	    int num=get_no_of_lines();
		    if (num==-1) break;
		    if (lines==line_number) {
			    add_line(buffer,line_number);
			    lines++;
		    }
		    else modify_line(buffer,line_number);
		    rad *p=head;
		    while (p->number != line_number) p=p->next;
		    if (yankflag==1) {
			    list<yank>::iterator it=Y.begin();
			    while (it!=Y.end()) {
				    Y.erase(it);
				    it=Y.begin();
			    }
			    yankflag=0;
		    }
		  for (yank_count=0; yank_count<num && p!=NULL; yank_count++) {
			    strcpy(yanknode.content,p->content);
			    Y.push_back(yanknode);
			    beep();
			    p=p->next;
		  }
		  yankflag=1;
        mvwprintw(top,0,45,"                 ",yank_count);
        mvwprintw(top,0,55," %d lines yanked     ",yank_count);
	wrefresh(top);
		  
		   break;
	     }
	     
	if (i==3) {     
yank_paste: if (yankflag==0)  { 
            mvwprintw(top,0,45,"no lines in the yank buffer ",yank_count);
	    wrefresh(top); break;
	  }
	  if (lines==line_number) {
		  add_line(buffer,line_number);
		  lines++;
	  }
	  else modify_line(buffer,line_number);
	  list<yank>::iterator it=Y.begin();
	  int templ=line_number+1;
	  while (it!=Y.end()) {
		  push_numbers(templ);
		  add_line(it->content,templ);
		  lines++;templ++;
		  it++;
	  }
	    break;
	}
              break;

     case 3: goto yank_cut; break;
     case 16: goto yank_paste; break;
     case 19: goto yank_sel; break;	      

end_del:
	   case 14:
       
       for (count=x_pos-leftmar; count<LINE_LENGTH; count++) buffer[count]='\0';
       if (strlen(buffer)!=0)  break;	 
line_del:
  case 12:
	if (line_number==lines) {
         for (int k=0; k<LINE_LENGTH; k++) buffer[k]='\0';
          MIN_COLS=leftmar; x_pos=leftmar;
	}
	else {
		      del_line (line_number);
		      for (int j=0; j<LINE_LENGTH; j++)
		      buffer[j]='\0';
		      --lines;
		      if (lines==0) { lines=0; line_number=0; break; }
		      if (line_number==lines) break;
	      strcpy (buffer, get_line (line_number));
		  x_pos = leftmar;
		  MIN_COLS = leftmar;
		}
	break;
word_del:
case 23:    
	    for (int j=strlen(buffer); j<LINE_LENGTH; j++) buffer[j]='\0';
	    count=x_pos-leftmar;
	    if (buffer[count]=='\0') break;
	    if (buffer[count]==' '|| buffer[count]=='\t') break;
	    while (buffer[count]!=' ') {
		    count--;if (count==-1) break;
	    }
	    count2=count+1;
	    count=x_pos-leftmar;
	    while (buffer[count]!='\t'&&buffer[count]!=' ') {
		    count++;if (buffer[count]=='\0') break;
	    }
	    count++;
	    while (buffer[count]==' '||buffer[count]=='\t') count++;
	    count3=LINE_LENGTH-(count-count2);
	    for (int j=count2; j<count3;  j++){
		    buffer[j]=buffer[j+(count-count2)];
	    }
	    x_pos=count2+leftmar;
	    for (int j=strlen(buffer); j<LINE_LENGTH; j++) buffer[j]='\0';
	/* entire line is empty, so delete it*/
	if (buffer[0]=='\0') {
	if (line_number==lines) {
         for (int k=0; k<LINE_LENGTH; k++) buffer[k]='\0';
          MIN_COLS=leftmar; x_pos=leftmar;
	}
	else {
		      del_line (line_number);
		      for (int j=0 ; j<LINE_LENGTH; j++) buffer[j]='\0';
		      --lines;
		      if (lines==0) { lines=0; line_number=0; break; }
		      if (line_number==lines) break;
	      strcpy (buffer, get_line (line_number));
		  x_pos = leftmar;
		  MIN_COLS = leftmar;
		}
	    }
	break;
		
case 32 ... 153 :		/* Most characters... */
	 started=1;
	    if (buffer[x_pos-leftmar-1]=='\n') { 
		    buffer[x_pos-leftmar-1]=' ';
		    x_pos=strlen(buffer)+leftmar;	   
	    } 
	     for (count = strlen (buffer) + 1; count > x_pos-leftmar; count--)
		buffer[count] = buffer[count - 1];
	      buffer[x_pos-leftmar] = c;x_pos++;
	      if (x == MAX_COLS - 1) 
		{
		  ++MIN_COLS;
		}
  	      wmove (win,y_pos-top_line+topmar, x_pos - MIN_COLS+leftmar); 
	  break;
	case '\t' :
	  started=1; int t,tt;t=strlen(buffer);tt=rightmar-leftmar;
         if (t==(LINE_LENGTH - 1)||(t==tt||t==tt-1||t==tt-2||t==tt-3||t==tt-4))
		  break;
	  else
	    {
	      for (count = strlen (buffer) + 1; count > x_pos-leftmar; count--)
		buffer[count] = buffer[count - 1];
	      buffer[x_pos-leftmar] = '\t'; int k=x_pos;
	      int p=x_pos%TAB_SPACING; 
	      x_pos++;
		for (count3 = 0; count3 < (TAB_SPACING-p); count3++)
		  {
		    for (count2 = strlen (buffer) +1; count2 > x_pos-leftmar; count2--)
		      buffer[count2] = buffer[count2 - 1];
		    buffer[x_pos-leftmar] = ' ';x_pos++;
		    if ((MIN_COLS-leftmar) < (x_pos - MAX_COLS))
			MIN_COLS = x_pos - MAX_COLS+leftmar;
		    wmove (win,y_pos-top_line+topmar, x_pos - MIN_COLS+leftmar);
		  }
	    }
	  break;
	case '\n':
	  started=1;
	  y_pos++;count3=0;
for (count = x_pos-leftmar; count < strlen (buffer); count++)
	    temp_buffer[count3++] = buffer[count];
	  temp_buffer[count3]='\0';
          buffer[x_pos-leftmar] = '\n';buffer[x_pos-leftmar+1]='\0';
	  wmove (win,y_pos-top_line+topmar, leftmar);
	  push_numbers (line_number);
	  add_line (buffer, line_number);
	  for (count = 0; count < LINE_LENGTH; count++)
	    {
	      buffer[count] = temp_buffer[count];
	      temp_buffer[count] = '\0';
	    }
	  if (y == MAX_LINES - 1)
	    {
	      ++top_line; wmove(win,y,leftmar);
	    }
	  else
	    wmove (win,++y, leftmar);
	  MIN_COLS = leftmar;
	  ++line_number;
	  ++lines;
	  x_pos = leftmar;
	  wmove(win,y, x_pos - MIN_COLS+leftmar);
	  break;
	case KEY_BACKSPACE:   
	  if (x_pos == leftmar && line_number == 0)
	    break;            
	  else if (x_pos == leftmar)
	    {
	      strcpy (temp_buffer, get_line (line_number - 1));
	      if (strlen (temp_buffer) + strlen (buffer) <
		  LINE_LENGTH && strlen(temp_buffer) + strlen (buffer) <=
                  (rightmar-leftmar))
		{
	     strcpy (temp_buffer, get_line (line_number - 1));
	     if (temp_buffer[strlen(temp_buffer)-1]=='\n') 
	      temp_buffer[strlen(temp_buffer)-1]='\0'; 
		--y_pos;  
                  if (lines > line_number)
		    {
		      del_line (line_number);
		      --lines;
		    }
		  --line_number;
		  x_pos = strlen (temp_buffer)+leftmar;
		  MIN_COLS = x_pos - MAX_COLS - 1+leftmar;
		  if (MIN_COLS < leftmar)
		    MIN_COLS = leftmar;
		  strcat (temp_buffer, buffer);
		  strcpy (buffer, temp_buffer);

		  if (y == topmar)
		    {
		      --top_line;
		     wmove (win,y, leftmar);
		    }
		  else
		    wmove (win,--y, leftmar);
		  wmove (win,y, x_pos - MIN_COLS+leftmar);
		  for (count = 0; count < LINE_LENGTH; count++)
		    temp_buffer[count] = '\0';
		}
	      else
		break;            
	    }
	  else
	    {
	      for (count = x_pos - 1; count < strlen (buffer)+leftmar; count++)
		buffer[count-leftmar] = buffer[(count-leftmar) + 1];
	      buffer[strlen (buffer) + 1] = '\0';
	      --x_pos;
	      if (x == leftmar)
		--MIN_COLS;
	      wmove (win,y, x_pos - MIN_COLS+leftmar);
	    }
	  break;
	case KEY_DC:	
	  if (x_pos == strlen (buffer)+leftmar)
	    {
	      if (line_number >= lines - 1)
		break;  
	      else
		{
		  strcpy (temp_buffer, get_line (line_number + 1));
		  if (strlen (temp_buffer) + strlen (buffer) <
	      LINE_LENGTH && strlen(temp_buffer) + strlen (buffer) <
              (rightmar - leftmar+1))
		    {
		      del_line (line_number + 1);
		      --lines;
		      strcat (buffer, temp_buffer);
		      wmove (win,y, x_pos - MIN_COLS+leftmar);
		      for (count = 0; count < LINE_LENGTH; count++)
			temp_buffer[count] = '\0';
		    }
		  else
		    break;  
		}
	    }
	  else
	    {
	      for (count = x_pos; count < strlen (buffer)+leftmar; count++)
		buffer[count-leftmar] = buffer[(count-leftmar) + 1];
	      buffer[strlen (buffer) + 1] = '\0';
	      wmove (win,y, x_pos - MIN_COLS+leftmar);
	    }
	  break;
	case KEY_LEFT:		/* Cursor left. */
	  if (x == leftmar)
	    {
	      if ((line_number == 0) && (MIN_COLS == leftmar))
		break;  
	      else if (MIN_COLS > leftmar)
		{
		  --MIN_COLS;
		  --x_pos;
		}
	      else
		{
			--y_pos;
		  if (line_number == lines)
		    {
		      add_line (buffer, line_number);
		      ++lines;
		    }
		  else
		    modify_line (buffer, line_number);
		  for (int j=0; j<LINE_LENGTH; j++) buffer[j]='\0';
		  strcpy (buffer, get_line (--line_number));
		  if (buffer == NULL)
		    {
		      fprintf (stderr, "Couldn't get any line!");
		      exit (1);
		    }
		  if (y == topmar)
		    {
		      --top_line;
		      wmove (win,y, leftmar);
		    }
		  else
		    wmove (win,--y, leftmar);
		  x_pos = strlen (buffer)+leftmar;
		  MIN_COLS = x_pos - (MAX_COLS - 1)+leftmar;
		  if (MIN_COLS < leftmar)
		    MIN_COLS = leftmar;
		  wmove (win,y, x_pos- MIN_COLS+leftmar);
		}
	    }
	  else
	    wmove (win,y, (--x_pos) - MIN_COLS+leftmar);
	  break;
	case KEY_RIGHT:	/* Cursor right. */

	   if (x_pos == strlen(buffer)+leftmar)
	    {
	    	 
	       if(line_number<lines-1)
		{				
	 	  ++y_pos;
	       	  modify_line (buffer, line_number);
		  for (int j=0; j<LINE_LENGTH; j++) buffer[j]='\0';
		  strcpy (buffer, get_line (++line_number));
		  if (buffer == NULL)
		    {
		      fprintf (stderr, "Couldn't get any line!");
		      exit (1);
		    }
		  if (y == MAX_LINES - 1)
		    {
		      ++top_line;
		      wmove (win,y, leftmar);
		    }
		  else
		    wmove (win,++y, leftmar);
		  x_pos = leftmar;
		  MIN_COLS = leftmar;
		  wmove (win,y, x_pos - MIN_COLS+leftmar);
		}
		else
			break;
	 	   	
	    }
	  else if (x == (MAX_COLS - 1))
	    {
	      ++x_pos;
	      ++MIN_COLS; 
	    	
	      wmove(win,y, x_pos - MIN_COLS+leftmar);
	    }
	else if(x_pos!=strlen(buffer)+leftmar)
	 {
	    wmove (win,y, (++x_pos) - MIN_COLS+leftmar);
	 	
	 }
	  break;                 
	  
	  
	case KEY_HOME:		/* Home: to beginning of line. */
	  x_pos = leftmar;
	  MIN_COLS = leftmar;
	  break;
	case KEY_END:		/* End: to end of line. */
	  x_pos = strlen(buffer)+leftmar;
	  if ((x_pos) > (MIN_COLS + (MAX_COLS - 1)-leftmar))
	    MIN_COLS = x_pos - (MAX_COLS - 1) +leftmar;
	  break;
	case KEY_UP:		/* Cursor up. */
	  if (line_number == 0)
	    break;              /* Removed all the beeps. */
	  else
	    {
		y_pos--;
	      if (line_number == lines)
		{
		  add_line (buffer, line_number);
		  ++lines;
		}
	      else
		modify_line (buffer, line_number);
		  for (int j=0; j<LINE_LENGTH; j++) buffer[j]='\0';
	      strcpy (buffer, get_line (--line_number));
	      if (buffer == NULL)
		{
		  fprintf (stderr, "Couldn't get any line!");
		  exit (1);
		}
	      if (y == topmar)
		{
		  --top_line;
		  wmove (win,y_pos-top_line+topmar, leftmar);
		}
	      else
		{	
			wmove (win,--y, leftmar);
		}
	      if (x_pos > strlen (buffer)+leftmar)
		x_pos = strlen (buffer)+leftmar;
	      if (x_pos < MIN_COLS)
		MIN_COLS = x_pos;
	      wmove (win,y, x_pos - MIN_COLS+leftmar);
	    }
	  break;
	case KEY_DOWN:		/* Cursor down. */
	  if (line_number >= lines - 1)
	    break;              /* Removed all the beeps. */
	  else
	    {
	      y_pos++;
	      modify_line (buffer, line_number);
		  for (int j=0; j<LINE_LENGTH; j++) buffer[j]='\0';
	      strcpy (buffer, get_line (++line_number));
	      if (buffer == NULL)
		{
		  fprintf (stderr, "Couldn't get any line!");
		  exit (1);
		}
	      if (y == MAX_LINES - 1)
		{
		  ++top_line;
		  wmove (win,y_pos-top_line+topmar, leftmar);
		}
	      else
		wmove (win,++y, leftmar);
	      if (x_pos > strlen (buffer)+leftmar)
		x_pos = strlen (buffer)+leftmar;
	      if (x_pos < MIN_COLS)
		MIN_COLS = x_pos;
	      wmove (win,y, x_pos - MIN_COLS+leftmar);
	    }
	  break;
	
	case (KEY_NPAGE)://page down
	  if (line_number >= lines - 1)
	    break;		/* Removed all the beeps. */
	  else
	    {
	      modify_line (buffer, line_number);
	      if (y == MAX_LINES - 1)
		{
		  line_number += (MAX_LINES - 1)-topmar;
		   if (line_number >= lines)
		    line_number = lines - 1;
		  top_line=((line_number)-(MAX_LINES-topmar - 1))+topmar;
		  y = (lines+topmar) - top_line - 1;
			y_pos=line_number+topmar;
		}
	      else
		{
		  y = MAX_LINES - 1;
		  	line_number = (top_line + (MAX_LINES-topmar)-1)-topmar;
		  if (line_number >= lines)
		    {
		      line_number = lines - 1;
		      y = (lines+topmar) - top_line - 1;
		    }
			y_pos=line_number+topmar;
		}
	      for (int j=0; j<LINE_LENGTH; j++) buffer[j]='\0';
	      strcpy (buffer, get_line (line_number));
	      if (x_pos > strlen (buffer)+leftmar)
		x_pos = strlen (buffer)+leftmar;
	      MIN_COLS = x_pos - (MAX_COLS - 1)+leftmar;
	      if (MIN_COLS < leftmar)
		MIN_COLS = leftmar;

	    }
	  break;
	case (KEY_PPAGE)://Page up
	  if (line_number == 0)
	    break;		/* Removed all the beeps. */
	  else
	    {
	      if (line_number >= lines)
		{
		  add_line (buffer, line_number);
		  ++lines;
		}
	      else
		modify_line (buffer, line_number);
	      if (y == topmar)
		{
		  line_number -= (MAX_LINES - 1)-topmar;
		  if (line_number < 0)
		    line_number = 0;
		  top_line = line_number+topmar;
		  y = topmar;
			y_pos=line_number+topmar;
		}
	      else
		{
		  y = topmar;
		  line_number = top_line-topmar;
		  if (line_number < 0)
		    {
		      line_number = 0;
		      y = topmar;
		    }
			y_pos=line_number+topmar;
		}
	      for (int j=0; j<LINE_LENGTH; j++) buffer[j]='\0';
	      strcpy (buffer, get_line (line_number));
	      if (x_pos > strlen (buffer)+leftmar)
		x_pos = strlen (buffer)+leftmar;
	      MIN_COLS = (x_pos - (MAX_COLS - 1))+leftmar;
	      if (MIN_COLS < leftmar)
                MIN_COLS = leftmar;
	    }
	  break;

     }// end of switch
  
/*take care of null characters */
for (int j=strlen(buffer); j<LINE_LENGTH; j++) buffer[j]='\0';

       

/* word wrapping code starts here */
rad *p=head; int i,flag,j;int templine=line_number;
flag=999;is_in_between=0;  isend=0;
if (strlen(buffer)<(rightmar-leftmar)) { flag=0; }
else {
if (p!=NULL) 
 while (p->number != line_number  ) { 
	  p=p->next; 
	 if (p==NULL) break;
        }
if (p==NULL) flag=1;
 else { flag=3; is_in_between=0; firsttime=0;
	 modify_line(buffer,p->number);
 }
}
dumc=0;

 while (flag!=0) {
	switch(flag) {
  case 1:
	  dumc=0;
	  if (strlen(buffer) < (rightmar-leftmar)) { flag=0; break; }
	  for (i=0; i<(rightmar-leftmar) && i<strlen(buffer); i++) {
	char ch=buffer[i];
	if (ch==' ' || ch=='\t' || ch=='\n') {
		for (j=0; j<=dumc; j++) dum_buffer[j]='\0';
		dumc=0; oldpos=i+1;
	}
	else {
		dum_buffer[dumc++]=ch; dum_buffer[dumc]='\0';
	}
}
while (i<strlen(buffer)) {
 dum_buffer[dumc++]=buffer[i++]; dum_buffer[dumc]='\0';
}
if (strlen(buffer)==strlen(dum_buffer)) {
	for (j=0; j<=dumc; j++) dum_buffer[j]='\0';
}
else for (int k=oldpos; k<LINE_LENGTH; k++) buffer[k]='\0';
add_line(buffer,line_number);
strcpy(buffer,dum_buffer);
 if (strlen(dum_buffer)!=0 ) {
	int len=strlen(dum_buffer);
	addnum=x_pos-(oldpos+leftmar);
	if (addnum<0) addnum*=-1;
	if (x_pos==addnum+leftmar+oldpos) {  
		isend=1; 
         x_pos=leftmar+addnum;
         wrefresh(bottom);
	}
 }
else x_pos=strlen(buffer)+leftmar;
for (int k=0; k<=dumc; k++) dum_buffer[k]='\0';
	  y_pos++;
	  if (y == MAX_LINES - 1)
	    {
	      ++top_line; wmove(win,y,leftmar);
	    }
	  else
	    wmove (win,++y, leftmar);
	  MIN_COLS = leftmar;
	  ++line_number;
	  ++lines;
	  wmove(win,y, x_pos - MIN_COLS+leftmar);
flag=0;
break;
 
case 3:
         if (strlen(p->content) <= (rightmar-leftmar)) {
           		flag=0; break;
	}
        is_in_between=1;
        for (j=0; j<LINE_LENGTH; j++) p_buffer[j]=dum_buffer[j]='\0';
	dumc=0;strcpy(p_buffer,p->content);oldpos=-1;
        for (i=0; i<(rightmar-leftmar);  i++) {
	 char ch=p_buffer[i];
	 if (ch==' ' || ch=='\t' )  oldpos=i+1;
	 if (ch=='\n') { oldpos=i+1; break; }
	 }
    if (oldpos==-1 || oldpos==rightmar-leftmar+1) oldpos=rightmar-leftmar;
   for (i=oldpos; i<strlen(p_buffer); i++) dum_buffer[dumc++]=p_buffer[i];
   dum_buffer[dumc]='\0';
  for (i=oldpos; i<LINE_LENGTH; i++) p_buffer[i]='\0';
   modify_line(p_buffer,p->number);
   
  if (firsttime==0) {
      for (j=oldpos; j<LINE_LENGTH; j++) buffer[j]='\0';
      firsttime=1;
 if (strlen(dum_buffer)!=0 ) {
	int len=strlen(dum_buffer);
	addnum=x_pos-(oldpos+leftmar);
	if (addnum<0) addnum*=-1;
	if (x_pos==addnum+leftmar+oldpos) {  
		isend=1; 
         x_pos=leftmar+addnum;
         wrefresh(bottom);
	}
 }
}
if (strlen(dum_buffer)==0) { flag=0; break; }
if (dum_buffer[strlen(dum_buffer)-1]=='\n' ) {
 push_numbers(p->number+1); 
 add_line(dum_buffer,p->number+1);lines++;
 flag=0; break;
}
if (strcmp(dum_buffer,dum2_buffer)==0)  {
 push_numbers(p->number+1); 
 add_line(dum_buffer,p->number+1);lines++;
 flag=0; break;
}
		
if (p->next==NULL) {  
	templine=p->number+1; 
	flag=0;
        if (strlen(dum_buffer)!=0)	
	 add_line(dum_buffer,templine);lines++;break;
}
  dum2_buffer[0]='\0';
  strcpy(dum2_buffer,p->next->content); 
  strcat(dum_buffer,p->next->content);
  modify_line(dum_buffer,p->next->number);
  p=p->next; flag=3 ;
   break;

   } /*end of switch(flag)*/
} /*end of while (flag)*/
/****************word wrapping ends here ********************/
   if (is_in_between){
      is_in_between=0;
	if (isend) {
		  y_pos++;
	    if (y == MAX_LINES - 1)
	    {
	      ++top_line; wmove(win,y,leftmar);
	    }
	  else
	    wmove (win,++y, leftmar);
	   MIN_COLS = leftmar;
	   ++line_number;
	   isend=0;
	   for (count=0; count<LINE_LENGTH; count++) buffer[count]='\0';
	   strcpy(buffer,get_line(line_number));
	 }
if (x_pos==rightmar) {
	   for (count=0; count<LINE_LENGTH; count++)  buffer[count]='\0';
	  strcpy(buffer,get_line(line_number+1));
	  line_number++;
	     y_pos++;
	  if (y == MAX_LINES - 1)
	    {
	      ++top_line; wmove(win,y,leftmar);
	    }
	  else
	    wmove (win,++y, leftmar);
	  MIN_COLS = leftmar;
	  x_pos=leftmar;
	  wmove(win,y, x_pos - MIN_COLS+leftmar);
 } 
}


if (some==1) {
	for (int i=1; i<maxy-2; i++) {
		wmove(left,i,0);
		if (i%2==1) waddch(left,'/');
		 else waddch(left,'\\');
	}
	for (int i=1; i<maxy-2; i++) {
		wmove(right,i,0);
		if (i%2==1) waddch(right,'\\');
		 else waddch(right,'/');
	}
        wrefresh(left); wrefresh(right);some=0;
}
else {
	for (int i=1; i<maxy-2; i++) {
		wmove(left,i,0);
		if (i%2==1) waddch(left,'\\');
		 else waddch(left,'/');
	}
	for (int i=1; i<maxy-2; i++) {
		wmove(right,i,0);
		if (i%2==1) waddch(right,'/');
		 else waddch(right,'\\');
	}
	wrefresh(left); wrefresh(right); some=1;
}

getyx (win,y, x);
      show_list(top_line, MIN_COLS, y, x);
      wmove (win,y_pos-top_line+topmar, leftmar);
      wclrtoeol (win);
      wattron(win,COLOR_PAIR(6));
      
     wattron(win,A_BOLD);
      for (count = MIN_COLS; count < (MIN_COLS + (MAX_COLS - 1)-leftmar) && 
	     (count < strlen(buffer)+leftmar); count++)
	{ 
		// if (count-leftmar == oldpos) wattron(win,A_REVERSE);
	  if (buffer[count-leftmar] == '\t')
	    waddch(win,' ');
	  else
	    waddch(win,buffer[count-leftmar]);
	} 
     wattroff(win,A_BOLD);
      wattroff(win,COLOR_PAIR(6));
      wmove (win,y_pos-top_line+topmar, x_pos-MIN_COLS+leftmar);
        mvwprintw(bottom,0,2," Menu selection: <Ctrl> [feyoah]      ");
      mvwprintw(bottom,0,maxx-30," INS Line:%d Col:%d  ",line_number+1,x_pos+1);
      wrefresh(bottom);    
       wrefresh(win);
        /* Updating the screen after each character. */
      wrefresh(bottom);
      wrefresh(win);
      //wattroff(win,A_REVERSE);
       }   //end of while
  finish (0);			/* This is the end... */

  }

static void
finish (int sig)
{
  clean_up ();

  endwin ();

  exit (0);
}


void
clean_up (void)
{
	wmove(win,topmar,leftmar);
  rad *temp = head, *prev = NULL;

  if (head != NULL)
    {
      while (temp != NULL)	/* Freeing all allocated memory. */
	{
	  free (temp->content);
	  prev = temp->next;
	  free (temp);
	  temp = prev;
	}
    }
  head = NULL;
}


void
show_list (int top_line, int MIN_COLS, int y, int x)
{
  rad *temp = head;
  int count, count2;

  werase(win);

  for(count =topmar; (temp!=NULL)&&((count-top_line)<MAX_LINES-topmar); count++)
    {
      if (temp->number >= top_line-topmar)
	{
	  wmove (win,count - top_line+topmar, leftmar);
	  for (count2 = MIN_COLS; count2 < (MIN_COLS + (MAX_COLS - 1)-leftmar) && (count2 < strlen(temp->content)+leftmar); count2++)
	    {
	      if (temp->content[count2-leftmar] == '\t')
		waddch(win,' ');
	      else
                 if (temp->content[count2-leftmar]=='\n') break;
		  else
		   waddch(win,temp->content[count2-leftmar]);
	    }
	}
      temp = temp->next;
    }
  wmove (win,y, x);
}
int search(char *sword,int& line_number,int& x_pos,int findagain) {
 rad *p=head; char buffer[LINE_LENGTH];
 if (p==NULL) return 0;
 int i=0; 
 if (findagain==1) {
	 while (p->number!=line_number) p=p->next;
	 i=x_pos-leftmar+strlen(sword);
 }
 else i=0;
 while (p!=NULL) {
	buffer[0]='\0'; 
  strcpy(buffer,p->content);
  while (1) {
     if (buffer[i]==sword[0]) {
          int j=0; int foundpos=i;	  
          while (buffer[i]==sword[j] && buffer[i]!='\0') { i++; j++; }
          if (j>=strlen(sword)) {
	     line_number=p->number; 
	     x_pos=foundpos+leftmar; return 1;
          }
     }
     if (buffer[i]=='\0') {  i=0; break; }  i++;
  }
  p=p->next;
 }
 return 0;
}
int search_exact(char *sword,int& line_number,int& x_pos,int findagain) {
 rad *p=head; char buffer[LINE_LENGTH];
 if (p==NULL) return 0;
 int i=0; 
 if (findagain==1) {
	 while (p->number!=line_number) p=p->next;
	 i=x_pos-leftmar+strlen(sword);
 }
 else i=0;
 while (p!=NULL) {
	buffer[0]='\0'; 
  strcpy(buffer,p->content);
  while (1) {
     if (buffer[i]==sword[0]) {
          int j=0; int foundpos=i;	  
          while (buffer[i]==sword[j] && buffer[i]!='\0') { i++; j++; }
          char c=buffer[i];
          if (j>=strlen(sword) && (c==' '||c=='\0'||c=='\t'||c==','||
				c=='.'||c=='?'||c=='!')) {
	     line_number=p->number; 
	     x_pos=foundpos+leftmar;
	     if (foundpos!=0) {
	      if (buffer[foundpos-1]==' ') return 1;
	     }
	     else return 1;
          }
     }
     if (buffer[i]=='\0') {  i=0; break; }  i++;
  }
  p=p->next;
 }
 return 0;
}
	
  	 
	 
	
  	 
	 
