
void
push_numbers (int line_number)
{
  rad *temp = head;

  while (temp != NULL)
    {
      if (temp->number == line_number)
	{
	  while (temp != NULL)
	    {
	      ++temp->number;
	      temp = temp->next;
	    }
	  return;
	}
      temp = temp->next;
    }
}


void
add_line (char *buffer, int line_number)
{
  rad *news = NULL, *temp = NULL, *prev = NULL;
   news = (rad *) malloc (sizeof (rad));
   if (!news)
    {
      fprintf (stderr, "Unable to allocate memory!");
      exit (1);
    }
	news->content = (char *) malloc (strlen (buffer) + 1);
  if (!news->content)
    {
      fprintf (stderr, "Unable to allocate memory!");
      exit (1);
    }
  strcpy (news->content, buffer); 
  news->number = line_number;
  news->next = NULL;
  if (head == NULL)
    {
      head = news;
      news->next = NULL;
    }
  else
    {
      if (news->number < head->number)
	{
	  news->next = head;
	  head = news;
	}
      else
	{
	  temp = head->next;
	  prev = head;

	  if (temp == NULL)
	    {
	      prev->next = news;
	      news->next = NULL;
	    }
	  else
	    {
	      while ((temp->next != NULL))
		{
		  if (news->number < temp->number)
		    {
		      news->next = temp;
		      prev->next = news;
		      break;
		    }
		  else
		    {
		      temp = temp->next;
		      prev = prev->next;
		    }
		}

	      if (temp->next == NULL)
		{
		  if (news->number < temp->number)
		    {
		      news->next = temp;
		      prev->next = news;
		    }
		  else
		    {
		      temp->next = news;
		      news->next = NULL;
		    }
		}
	    }
	}
    }
}


void
modify_line (char *buffer, int line_number)
{
  rad *temp = head;
  while (temp != NULL)
    {
      if (temp->number == line_number)
	{
	  temp->content[0] = '\0';
	  temp->content = (char *) realloc (temp->content, strlen (buffer) + 1);
	  if (temp->content == NULL)
	    {
	      fprintf (stderr, "Failed to reallocate memory!");
	      exit (1);
	    }
	  strcpy (temp->content, buffer);
	  return;
	}
      temp = temp->next;
    }
}


void
del_line (int line_number)
{
  rad *temp = head, *prev = head;

  if (head->number == line_number)
    {
      head = temp->next;
      free (temp->content);
      free (temp);
    }
  else
    {
      while (temp != NULL)
	{
	  prev = temp;
	  temp = temp->next;
	  if (temp->number == line_number)
	    {
	      prev->next = temp->next;
	      free (temp->content);
	      free (temp);
	      break;
	    }
	}
    }
  temp = head;
  while (temp != NULL)
    {
      if (temp->number >= line_number)
	--temp->number;
      temp = temp->next;
    }
}


char *
get_line (int line_number)
{
  rad *temp = head;

  while (temp != NULL)
    {
      if (temp->number == line_number)
	return temp->content;
      else
	temp = temp->next;
    }
  return NULL;
}

void adjust_list(int &lines) {
 rad *p=head;
 head=NULL;
 char buffer[LINE_LENGTH],dum_buffer[LINE_LENGTH];
 int dumc,oldpos,i,line=0;
 for (i=0; i<LINE_LENGTH; i++) 
	 buffer[i]=dum_buffer[i]='\0';
 while (p!=NULL) {
	 strcat(dum_buffer,p->content);
	 if (strlen(dum_buffer)>=rightmar-leftmar ) break;
	 if (dum_buffer[strlen(dum_buffer)-1]=='\n') {
		 add_line(dum_buffer,line++);
		 for (i=0; i<LINE_LENGTH; i++) dum_buffer[i]='\0';
		 p=p->next; continue;
	 }
	 if (p->next!=NULL) {
	 if (strlen(dum_buffer)+strlen(p->next->content) >= LINE_LENGTH) break;
	 }
	 p=p->next;
 }
 
while (p!=NULL) {
	for (i=0; i<LINE_LENGTH; i++) buffer[i]='\0';
	strcpy(buffer,dum_buffer);
  dumc=0;oldpos=-1;
   for (i=0; i<(rightmar-leftmar) && i<strlen(buffer);  i++) {
    char ch=buffer[i];
    if (ch==' ' || ch=='\t' )  oldpos=i+1;
    if (ch=='\n') { oldpos=i+1; break; }
   }
  if (oldpos==-1 || oldpos==rightmar-leftmar+1) oldpos=rightmar-leftmar;
  for (i=oldpos; i<strlen(buffer); i++) dum_buffer[dumc++]=buffer[i];
   dum_buffer[dumc]='\0';
  for (i=oldpos; i<LINE_LENGTH; i++) buffer[i]='\0';
   add_line(buffer,line++);
   if (strlen(dum_buffer)>=rightmar-leftmar) continue;
   if (dum_buffer[strlen(dum_buffer)-1]=='\n' ) {
      add_line(dum_buffer,line++);
      for (i=0; i<LINE_LENGTH; i++) dum_buffer[i]='\0';
   }
 p=p->next; 
 while (p!=NULL) {
	 strcat(dum_buffer,p->content);
	 if (dum_buffer[strlen(dum_buffer)-1]=='\n') break;
	 if (strlen(dum_buffer)>=rightmar-leftmar) break;
	 if (p->next!=NULL) {
	 if (strlen(dum_buffer)+strlen(p->next->content) >= LINE_LENGTH) break;
	 }
	 p=p->next;
}
}
if (strlen(dum_buffer)!=0)  add_line(dum_buffer,line++);
lines=line;
/******** clean up the old list ********/  
rad *temp = p, *prev = NULL;

  if (p != NULL)
    {
      while (temp != NULL)	/* Freeing all allocated memory. */
	{
	  free (temp->content);
	  prev = temp->next;
	  free (temp);
	  temp = prev;
	}
    }
}

