class window
{
 protected:WINDOW *win;
         PANEL *pan;
 public:window() { win =NULL; pan = NULL; }
        window(int row,int col,int y,int x,int pair) {
		create(row,col,x,y,pair);
	}	
	void create(int row,int col,int x,int y,int pair)
	{
	 win=newwin(row,col,y,x);
	 wcolor_set(win,pair,0);
	 for(int i=0;i<row;i++)
	   for(int j=0;j<col;j++)
	     mvwaddch(win,i,j,' ');
	 pan=new_panel(win);
	}
	void wbox()
	{  wborder(win,0,0,0,0,0,0,0,0);  }
	void addchar(int x,int y,const char *a)
	{  mvwaddstr(win,y,x,a);  }
	void display()
	{
	 top_panel(pan);
         update_panels();
	 doupdate();
	}
	WINDOW *ptr()
	{  return win;  }
	void hide() {
		hide_panel(pan);
	}
	//************NEW FUNCTONS***************************
	
            void display_string(int x,int y,const char* str)
            {
             mvwaddstr(win,x,y,str);
            }
            void display_string_array(const char *str[],int n,int x,int y)
            {
             for(int i=0; i<n ;i++)
               mvwaddstr(win,x+i,y,str[i]);                        //relative
            }
             void display_strip(int curr_row,int prev_row,int col1,int col2,int true_pair,int highlight_pair)
             {
               char ch;

               wcolor_set(win,true_pair,0);
               for(int i=col1;i<col2;i++)
               {
                ch=mvwinch(win,prev_row,i);//&&A_CHARTEXT;
                mvwaddch(win,prev_row,i,ch);
               }

               wcolor_set(win,highlight_pair,0);
               for(int i=col1;i<col2;i++)
               {
                ch=mvwinch(win,curr_row,i);
                mvwaddch(win,curr_row,i,ch);
               }
	       wcolor_set(win,true_pair,0); 	
               wmove(win,curr_row,0);
               update_panels();  doupdate(); //show();

             }
	



	~window() {
		if(win) {
			//hide_panel(pan);
			//del_panel(pan);
			//delwin(win);
			//update_panels();
			//doupdate();
		}
	}
	virtual void up() { }   
	virtual void down() { }   
	virtual int detect() { return -1;}
};

//*******************POPDOWN MENU WINDOWS**************
class popdown:public window
{
 protected:int rows,cols,crow,w_num;
 public:void create(int row,int col,int x,int y,char ch[],int n)
        {
	 rows=row;  cols=col;  crow=0;  w_num=n;
	 window::create(row,col,x,y,2);
	 mvwaddstr(win,1,0,ch);
	 down();
	}
	void create(int row,int col,int x,int y,string a[],int n) {
		rows=row; cols=col; crow=0; w_num=n;
		window::create(row,col,x,y,2);
		for(int i=0;i<rows-2;i++)
			mvwaddstr(win,i+1,1,a[i].c_str());
		down();
	}	
	void up()
	{
	 wmove(win,crow,0);
	 wchgat(win,cols,COLOR_PAIR(2),2,0);
	 wchgat(win,cols,A_NORMAL,2,0);
         if(crow<2) crow=rows-1;
         crow--;
	 wmove(win,crow,0);
	 wchgat(win,cols,COLOR_PAIR(3),3,0);
	 wchgat(win,cols,A_BOLD,3,0);
	 wbox();
	} 
	void down()
	{
	 wmove(win,crow,0);
	 wchgat(win,cols,COLOR_PAIR(2),2,0);
	 wchgat(win,cols,A_NORMAL,2,0);
         if(crow>=rows-2)  crow=0;
         crow++;
	 wmove(win,crow,0);
	 wchgat(win,cols,COLOR_PAIR(3),3,0);
	 wchgat(win,cols,A_BOLD,3,0);
	 wbox();
	}
        int detect()
        {
         if(w_num==1) return crow;
         if(w_num==2) return crow+7;
         if(w_num==3) return crow+14;
         if(w_num==4) return crow+16;
         return -1;
        }  
};

//**********************OPEN & SAVE WINDOWS ***************
class opensave {
  private:window owin,iwin;
  	  string fname;
  	  int stringpos,curpos,frontpos;
	  bool last;
  public:opensave(char *ch) {
  	   owin.create(6,41,20,8,8);
	   wattron(owin.ptr(),A_BOLD); 
	   owin.wbox();
	   owin.addchar(2,1,"Enter the file name ");
	   iwin.create(1,35,22,11,4);
	   wattron(iwin.ptr(),A_BOLD);
	   owin.addchar(15,0,ch);	
	   stringpos=curpos=frontpos=0;
	   fname="";
	   last=1;
	}
	~opensave() { 
	iwin.hide();
	owin.hide();
	}
  int getfile(string& fname) {
 	string temp="";  
  	owin.display();
	iwin.display();
	chtype ch;
	curs_set(cursmode);
	keypad(iwin.ptr(),TRUE);
	wmove(iwin.ptr(),0,curpos);
	while(1) {
	  ch=wgetch(iwin.ptr());
	  switch(ch) {
	  	case 27:return 0;
		case KEY_LEFT:
			      if(stringpos==0 && last==0 )
		                { beep();  break; }
        			if(!last)
                			stringpos--;
        			if(curpos)
                			curpos--;
        			if(!curpos)
                			frontpos=stringpos;
        			if(last==1 && fname.length()!=0)
                			last=0;
			      break;
		case KEY_RIGHT://moveright();
			       if(last) beep();
			       else {
			       	if(stringpos+1==fname.length())
					last=1;
				else  stringpos++;
				if(curpos<34) curpos++;	
				frontpos=stringpos-curpos+last;
			       }	
			       break;
		case KEY_DC:if(fname.length()<1 || last==1)
				beep();
			    else {
				if(stringpos+1==fname.length()) {
					last=1;
					fname.erase(fname.begin()+stringpos);
					if(stringpos>0)  stringpos--;
				}
				else 
					fname.erase(fname.begin()+stringpos);
			    }	
			    break;
		case KEY_BACKSPACE:if(stringpos != 0 || last==1 ) {
					ungetch(KEY_DC);
				        ungetch(KEY_LEFT);
				   }	
				   break;
		case '\n':return 1;
		default:
			if(fname.length()==0) {
				fname+=ch;
				curpos++;  frontpos=0;
				break;
			}
		        else if(last) {
				fname+=ch;
				stringpos++;
				if(curpos<34) curpos++;
			}
			else {
				fname.insert(fname.begin()+stringpos,ch);
				stringpos++;
				if(curpos<34) curpos++;
			}
			frontpos=stringpos-curpos+last;
			break;
	      }  // end switch
	      temp="";
	      for(int i=frontpos;i<fname.length();i++)
	      	temp+=fname[i];
	      for(int i=fname.length()-frontpos;i<35;i++)
	        temp+=" ";
	     // owin.display();	
	      wmove(iwin.ptr(),0,0);
	      waddstr(iwin.ptr(),temp.c_str());
	      iwin.display();
	      wmove(iwin.ptr(),0,curpos);
	 }//end while
	 curs_set(0);
	 return 1;
  } 	 
};

//**********************MESSAGE DISPLAY WINDOWS**************
class GENERIC_WINDOW
{
 private:
 	 window *background_window;
	 window *main_message;
 	 window *generic[10];
	 int start[10][2];
 	 int current,no_of_options,start_col,offset;	
 public:
 	GENERIC_WINDOW()
 	{
	 current=0;
 	}
	~GENERIC_WINDOW()
	{
	 for(int i=0;i<no_of_options;i++)
		 delete generic[i];
	 delete main_message;
	 delete background_window;
	}
 	int handle_menu(const char *message,int n,...)
	{
	 char *str;
	 chtype ch;
	 curs_set(0);
	 no_of_options=n;
	 int width=0;
	 va_list arg_ptr;
	 va_start(arg_ptr,n);
	 for(int i=0;i<n;i++)
	 {
	  str=va_arg(arg_ptr,char *);
	  start[i][0]=width;
	  start[i][1]=strlen(str);
	  width+=start[i][1]+2;
	 }
	 va_end(arg_ptr);
	 offset=(39-width)/(n+1);
	 background_window=new window(6,41,8,20,8);
	 wattron(background_window->ptr(),A_BOLD);
	 background_window->wbox();
	 main_message=new window(2,37,9,22,8);
	 wattron(main_message->ptr(),A_BOLD);
	 main_message->display_string(0,0,message);
	 main_message->display();  //display_on_top();
	 va_start(arg_ptr,n);
	 for(int i=0;i<n;i++)
	 {
	  str=va_arg(arg_ptr,char *);
	  start[i][0]=20+start[i][0]+(offset+1)*(i+1);
	  generic[i]=new window(1,strlen(str)+2,12,start[i][0],8);
	  //generic[i]->wbox();
	  wattron(generic[i]->ptr(),A_BOLD);
	  generic[i]->display_string(0,1,str);
	 }
	 va_end(arg_ptr);
	 generic[0]->display_strip(0,0,1,start[0][1]+1,8,5);
	 generic[0]->display();   //display_on_top();
	 while(1)
	 {
	  ch=getch();
          switch(ch)
	  {
	   case '\n':curs_set(cursmode);
			return current;
	   case '\t':
     generic[current]->display_strip(0,0,1,start[current][1]+1,5,8);
                    current=(++current)%n;
     generic[current]->display_strip(0,0,1,start[current][1]+1,8,5);
		break;
	   case 27:curs_set(cursmode);
			return -1;	
	  }	
	 }
	}
};
//*****************PAGE SETUP WINDOW*************

#define UPDATEWINDOW  wmove(piwin.ptr(),2,2); wprintw(piwin.ptr(),"Left margin     %2d     Right margin    %2d     Top margin      %2d     Bottom margin   %2d ",lm,rm,tm,bm); piwin.display_strip(pos+2,pos+1,2,15,8,4); piwin.wbox();  piwin.display();

class margin_window {
  private:int pos,curr,retval;
	  int rm,lm,tm,bm;
  public:margin_window() {
  		pos=curr=rm=lm=tm=bm=0;
                retval=1;
	 }
  int getmargin(int& LM,int& RM,int& TM,int& BM) {
	window piwin;
	lm=LM; rm=RM; tm=TM; bm=BM;
	piwin.create(9,23,25,8,8);
	wattron(piwin.ptr(),A_BOLD);
	//UPDATEWINDOW;
        mvwaddstr(piwin.ptr(),7,3,"Default       OK");	
        piwin.display_strip(7,7,10*retval+3,10*retval+10,8,5);
	UPDATEWINDOW;
	piwin.wbox();
	piwin.display();
	chtype ch;
	keypad(piwin.ptr(),TRUE);
	while(1) {
	  UPDATEWINDOW;
	  //piwin.display_strip(pos+2,pos+1,2,15,8,4);
	  ch=getch();
	  switch(ch) {
	    case KEY_UP:switch(pos) {
	    		  case 0:if(lm<(78-rm-10)) lm++;
				 break;       
			  case 1:if(rm<(78-lm-10)) rm++;
			  	 break;
			  case 2:if(tm<(21-bm-2)) tm++;
			  	 break;
			  case 3:if(bm<(21-tm-2)) bm++;
			  	 break;
			  default:break;
			}
			UPDATEWINDOW;
			break;
	    case KEY_DOWN:switch(pos) {
	    		   case 0:if(lm>0) lm--;
			   	  break;
			   case	1:if(rm>0) rm--;
			   	  break;
			   case 2:if(tm>0) tm--;
			   	  break;
			   case 3:if(bm>0) bm--;
			   	  break;
			   default:break;
			  } 
			  UPDATEWINDOW;
			  break;
	    case KEY_NPAGE:if(pos>=3) pos=0;
                           else pos++;
                           break;    
            case KEY_PPAGE:if(pos<=0) pos=3;
                           else pos--;
                           break;
	    case '\t':if(retval==1) { 
			retval=0;
			piwin.display_strip(7,7,13,20,5,8);
                        piwin.display_strip(7,7,3,10,8,5);
                      }
		      else {
		        retval=1;
			piwin.display_strip(7,7,3,10,5,8);
			piwin.display_strip(7,7,13,20,8,5);
		      }	
		      break;
	    case 27:return 0;
	    case '\n':if(retval==0) {
	    		  lm=rm=tm=bm=0;
			  break;
		      }	  
	    	      LM=lm; RM=rm; TM=tm; BM=bm;
	    	      return 1;
	    default:break;
	  }
        }	  
	return 1;
  }
}; 

//*************** COLOR SELECTION WINDOW ************

 class color_window {
  private:int curr,pos[2],ppos[2],tabc;
  public:color_window() {
  		pos[0]=pos[1]=curr=0;
		ppos[1]=ppos[0]=1;
	 }
	 int getcolor(int& fg,int& bg,bool& fonttype,int& TAB) {
	   tabc=TAB;
	   pos[0]=fg; pos[1]=bg;
	   ppos[0]=fg-1; ppos[1]=bg-1;
	   if(ppos[0]<0) ppos[0]=7;
	   if(ppos[1]<0) ppos[1]=7;
	   init_pair(5,COLOR_RED,COLOR_WHITE);
	   window cwin(15,42,5,15,8);
	   wattron(cwin.ptr(),A_BOLD);
	   mvwaddstr(cwin.ptr(),2,3,"FOREGROUND     BACKGROUND   FONT");
	   mvwaddstr(cwin.ptr(),3,3,"( )Black       ( )Black    ( )Normal");
	   mvwaddstr(cwin.ptr(),4,3,"( )Red         ( )Red      ( )Bold");
	   mvwaddstr(cwin.ptr(),5,3,"( )Green       ( )Green");
           mvwaddstr(cwin.ptr(),6,3,"( )Yellow      ( )Yellow");
	   mvwaddstr(cwin.ptr(),7,3,"( )Blue        ( )Blue      TAB SPACE");
	   mvwaddstr(cwin.ptr(),8,3,"( )Magenta     ( )Magenta   [  ]");
	   mvwaddstr(cwin.ptr(),9,3,"( )Cyan        ( )Cyan");
	   mvwaddstr(cwin.ptr(),10,3,"( )White       ( )White");
	   mvwaddstr(cwin.ptr(),12,3,"  Default       Cancel       Ok");
	   cwin.wbox();
	   //cwin.display();
	   mvwaddstr(cwin.ptr(),pos[0]+3,4,"*");
	   mvwaddstr(cwin.ptr(),pos[1]+3,19,"*");
	   if(fonttype) mvwaddstr(cwin.ptr(),4,31,"*");
	   else mvwaddstr(cwin.ptr(),3,31,"*");
	   mvwprintw(cwin.ptr(),8,32,"%2d",tabc);
	   cwin.display_strip(2,2,3,13,8,5);
	   chtype ch;
	   while(1) {
	     cwin.display();
	     switch(ch=getch()) {
	       case KEY_UP:switch(curr) {
	                    case 0:
			    case 1:ppos[curr]=pos[curr];
	       		     	   mvwaddstr(cwin.ptr(),pos[curr]+3,curr*15+4," ");
				   if(pos[curr]==0) 
	       		  	  	pos[curr]=7;
			     	   else
			   	  	pos[curr]--;
			     	   mvwaddstr(cwin.ptr(),pos[curr]+3,curr*15+4,"*");
				   break;	  
			    case 2:if(fonttype==0){
			    		fonttype=1;
					mvwaddstr(cwin.ptr(),3,31," ");
				   	mvwaddstr(cwin.ptr(),4,31,"*");
				   }	
			           else {
				   	fonttype=0;
					mvwaddstr(cwin.ptr(),4,31," ");
				  	mvwaddstr(cwin.ptr(),3,31,"*");
				   }	
				   break;
			    case 3:if(tabc<50)
			    		tabc++;
				   mvwprintw(cwin.ptr(),8,32,"%2d",tabc);	
			           break;
			   }	
			   break;
	       case KEY_DOWN:
			     switch(curr) {
			       case 0:
			       case 1:for(int i=0;i<7;i++)
			     		ungetch(KEY_UP);
			     	      break;
			       case 2:ungetch(KEY_UP);
			              break;
			       case 3:if(tabc>1)
			                 tabc--;
				      mvwprintw(cwin.ptr(),8,32,"%2d",tabc); 
			              break; 
			     }
			     break;
	       case '\t':
			 switch(curr) {
                          case 0:cwin.display_strip(2,2,3,13,5,8);
			         break;
			  case 1:cwin.display_strip(2,2,18,29,5,8);
			         break;
			  case 2:cwin.display_strip(2,2,31,35,5,8);
			         break;
			  case 3:cwin.display_strip(7,7,31,41,5,8);
			         break;
			  case 4:cwin.display_strip(12,12,5,12,5,8);
			         break;
			  case 5:cwin.display_strip(12,12,19,25,5,8);
			         break;
			  case 6:cwin.display_strip(12,12,32,34,5,8);
			         break;
			 }	 
			 if(curr>=6) curr=0;
			 else curr++;
			 switch(curr) {
                           case 0:cwin.display_strip(2,2,3,13,8,5);
                                  break;
                           case 1:cwin.display_strip(2,2,18,29,8,5);
                                  break;
                           case 2:cwin.display_strip(2,2,31,35,8,5);
                                  break;
                           case 3:cwin.display_strip(7,7,31,41,8,5);
	                          break;
	                   case 4:cwin.display_strip(12,12,5,12,8,5);
	                          break;
	                   case 5:cwin.display_strip(12,12,19,25,8,5);
	                          break;
	                   case 6:cwin.display_strip(12,12,32,34,8,5);
	                          break;
	                 }
			 break;
	       case '\n':switch(curr) {
			  case 4:tabc=8;
			  	 mvwaddstr(cwin.ptr(),pos[0]+3,4," ");
				 mvwaddstr(cwin.ptr(),pos[1]+3,19," ");
			         pos[0]=7; pos[1]=4;
				 mvwaddstr(cwin.ptr(),pos[0]+3,4,"*");
				 mvwaddstr(cwin.ptr(),pos[1]+3,19,"*");
				 if(fonttype==0) {
				 	fonttype=1;
					mvwaddstr(cwin.ptr(),3,31," ");
	                       		mvwaddstr(cwin.ptr(),4,31,"*");
				 }
				 mvwprintw(cwin.ptr(),8,32,"%2d",tabc);
			         break;
			  case 5:init_pair(5,COLOR_BLACK,COLOR_WHITE);
			         return 0;
			  case 6:init_pair(1,pos[0],pos[1]);
			 	 init_pair(5,COLOR_BLACK,COLOR_WHITE);
			 	 fg=pos[0];  bg=pos[1];
			 	 if(tabc == TAB)
				    return 1;
				 TAB=tabc;   
				 return 2;
			 default:break;	 
			 }
			 break;
	       case 27:init_pair(5,COLOR_BLACK,COLOR_WHITE);
		       return 0;
	     }
	   }  
	   return 0;
	 }  
};	   
