static void
finish ()
{
  clean_up ();

  endwin ();

  exit (0);
}


void
clean_up (void)
{
	wmove(win,0,0);
  rad *temp = head, *prev = NULL;

  if (head != NULL)
    {
      while (temp != NULL)	/* Freeing all allocated memory. */
	{
	  free (temp->content);
	  prev = temp->next;
	  free (temp);
	  temp = prev;
	}
    }
  head = NULL;
}

void
push_numbers (int line_number)
{
  rad *temp = head;

  while (temp != NULL)
    {
      if (temp->number == line_number)
	{
	  while (temp != NULL)
	    {
	      ++temp->number;
	      temp = temp->next;
	    }
	  return;
	}
      temp = temp->next;
    }
}



void
add_line (char *buffer, int line_number)
{
  rad *news = NULL, *temp = NULL, *prev = NULL;

  news = (rad *) malloc (sizeof (rad));
  if (!news)
    {
      fprintf (stderr, "Unable to allocate memory!");
      exit (1);
    }
  news->content = (char *) malloc (strlen (buffer) + 1);
  if (!news->content)
    {
      fprintf (stderr, "Unable to allocate memory!");
      exit (1);
    }
  strcpy (news->content, buffer);
  news->number = line_number;
  news->next = NULL;


  if (head == NULL)
    {
      head = news;
      news->next = NULL;
    }
  else
    {
      if (news->number < head->number)
	{
	  news->next = head;
	  head = news;
	}
      else
	{
	  temp = head->next;
	  prev = head;

	  if (temp == NULL)
	    {
	      prev->next = news;
	      news->next = NULL;
	    }
	  else
	    {
	      while ((temp->next != NULL))
		{
		  if (news->number < temp->number)
		    {
		      news->next = temp;
		      prev->next = news;
		      break;
		    }
		  else
		    {
		      temp = temp->next;
		      prev = prev->next;
		    }
		}

	      if (temp->next == NULL)
		{
		  if (news->number < temp->number)
		    {
		      news->next = temp;
		      prev->next = news;
		    }
		  else
		    {
		      temp->next = news;
		      news->next = NULL;
		    }
		}
	    }
	}
    }
}



void
modify_line (char *buffer, int line_number)
{
  rad *temp = head;
  while (temp != NULL)
    {
      if (temp->number == line_number)
	{
	  temp->content[0] = '\0';
	  temp->content = (char *) realloc (temp->content, strlen (buffer) + 1);
	  if (temp->content == NULL)
	    {
	      fprintf (stderr, "Failed to reallocate memory!");
	      exit (1);
	    }
	  strcpy (temp->content, buffer);
	  return;
	}
      temp = temp->next;
    }
}


void
del_line (int line_number)
{
  rad *temp = head, *prev = head;

  if (head->number == line_number)
    {
      head = temp->next;
      free (temp->content);
      free (temp);
    }
  else
    {
      while (temp != NULL)
	{
	  prev = temp;
	  temp = temp->next;
	  if (temp->number == line_number)
	    {
	      prev->next = temp->next;
	      free (temp->content);
	      free (temp);
	      break;
	    }
	}
    }
  temp = head;
  while (temp != NULL)
    {
      if (temp->number >= line_number)
	--temp->number;
      temp = temp->next;
    }
}

char *
get_line (int line_number)
{
  rad *temp = head;

  while (temp != NULL)
    {
      if (temp->number == line_number)
	return temp->content;
      else
	temp = temp->next;
    }
  return NULL;
}

void
show_list (int top_line, int MIN_COLS, int y, int x)
{
  rad *temp = head;
  int count, count2;

  werase(win);

  for(count=0; (temp != NULL) && ((count - top_line) < MAX_LINES-TOP_VAL); count++)
    {
      if (temp->number >= top_line)
	{
	  wmove (win,count-top_line+TOP_VAL,LOH);
	  for (count2 = MIN_COLS;count2<(MIN_COLS + (MAX_COLS - 1) - LOH) &&
		 (count2 < strlen(temp->content)); count2++)
	    {
	      if (temp->content[count2] == '\t')
		waddch(win,' ');
	      else
		waddch(win,temp->content[count2]);
	    }
	}
      temp = temp->next;
    }
  wmove (win,y, x);
}

